'$DYNAMIC

DECLARE SUB battle (ennum%)
DECLARE SUB battletext (text$)
DECLARE SUB bevelbox (x1%, y1%, x2%, y2%, col%, shade1%, shade2%, fill%)
DECLARE SUB changemap ()
DECLARE SUB clearscreen (mode%)
DECLARE SUB clrkbuffer ()
DECLARE SUB doscroll (scrolldir$)
DECLARE SUB doenattack (attackname$, damage%)
DECLARE SUB doitem (item%, text$)
DECLARE SUB doscript (scriptname$, scriptnum%)
DECLARE SUB dotrans (x1%, y1%, x2%, y2%)
DECLARE SUB drawbox (x1%, y1%, x2%, y2%, col%, shade1%, shade2%)
DECLARE SUB enattack (attackname$)
DECLARE SUB endgame ()
DECLARE SUB extractarray (xextract%, yextract%, array1%(), array2%())
DECLARE SUB fadeout (col1%, col2%)
DECLARE SUB fadein (col1%, col2%)
DECLARE SUB getscrn (x1%, y1%, x2%, y2%)
DECLARE SUB growbevelbox (x1%, y1%, x2%, y2%, col%, shade1%, shade2%, steps%)
DECLARE SUB growbox (x1%, y1%, x2%, y2%, col%, shade1%, shade2%, steps%)
DECLARE SUB initvars ()
DECLARE SUB inkey ()
DECLARE SUB inn (price%)
DECLARE SUB inputstring (xfnt%, yfnt%, colour%, text$, var$, maxlength%, xshade%, yshade%, bgcolor%)
DECLARE SUB inputvar (xfnt%, yfnt%, colour%, text$, var%, maxlength%, xshade%, yshade%, bgcolor%)
DECLARE SUB itemnamesort ()
DECLARE SUB itemtypesort ()
DECLARE SUB loaden (file$)
DECLARE SUB loadfont (filename$)
DECLARE SUB loadmagic (file$)
DECLARE SUB loadmap (filename$)
DECLARE SUB loadpalette (filename$)
DECLARE SUB loadshop (shopname$, numitems%)
DECLARE SUB loadsprite (file$, Spritearray%())
DECLARE SUB loadsprite2 (file$, Spritearray%())
DECLARE SUB loadtiles1 (tilename$)
DECLARE SUB loadtiles2 (tilename$)
DECLARE SUB movescrn (x1%, y1%, x2%, y2%, xoff%, yoff%)
DECLARE SUB NPCinteract (interx%, intery%)
DECLARE SUB NPCmove (NPC%, direction%)
DECLARE SUB NPCshow (NPC%)
DECLARE SUB pal (colour%, r%, g%, B%)
DECLARE SUB pastearray (xpaste%, ypaste%, array1%(), array2%(), tilenum%)
DECLARE SUB pause (seconds#)
DECLARE SUB playani (file$, anix%, aniy%, xsize%, ysize%, delay#)
DECLARE SUB playani2 (aniarray%(), tilenum1%, tilenum2%, anix%, aniy%, xchng%, ychng%, frames%, delay#)
DECLARE SUB putscrn (xoff%, yoff%)
DECLARE SUB question (speaker$, text$)
DECLARE SUB readscript ()
DECLARE SUB settrans ()
DECLARE SUB shop (shopname$)
DECLARE SUB showequip ()
DECLARE SUB showfont (xfnt%, yfnt%, colour%, text$, shadex%, shadey%)
DECLARE SUB showitems (inbattle%)
DECLARE SUB showmagic (inbattle%)
DECLARE SUB showload (loaded%)
DECLARE SUB showquit ()
DECLARE SUB showsave ()
DECLARE SUB showscreen (fade%)
DECLARE SUB showstats ()
DECLARE SUB skipscript ()
DECLARE SUB status ()
DECLARE SUB textbox (speaker$, text$)
DECLARE SUB transbox (x1%, y1%, x2%, y2%, col%, shade1%, shade2%)
DECLARE SUB useitem (item%, inbattle%)
DECLARE SUB usemagic (spell%, inbattle%)
DECLARE SUB wingame ()

TYPE rgb
        r AS INTEGER
        g AS INTEGER
        B AS INTEGER
END TYPE

TYPE mapchange
        x AS INTEGER
        y AS INTEGER
        mapname AS STRING * 12
        newx AS INTEGER
        newy AS INTEGER
END TYPE

TYPE edgemapchange
        mapname AS STRING * 12
        x AS INTEGER
        y AS INTEGER
END TYPE

TYPE NPC
        x AS INTEGER
        y AS INTEGER
        NPCname AS STRING * 12
        spriteset AS INTEGER
        direction AS INTEGER
        scriptnum AS INTEGER
END TYPE

TYPE item
        itemname AS STRING * 12
        itemtype AS STRING * 12
        strength AS INTEGER
        cost AS INTEGER
END TYPE

TYPE magic
        spellname AS STRING * 12
        level AS INTEGER
        cost AS INTEGER
        hitpercent AS INTEGER
        useoutofbattle AS INTEGER
        learned AS INTEGER
END TYPE

TYPE weapon
        weaponname AS STRING * 12
        strength AS INTEGER
END TYPE

TYPE armor
        armorname AS STRING * 12
        defense AS INTEGER
END TYPE

TYPE shield
        shieldname AS STRING * 12
        evade AS INTEGER
END TYPE

TYPE shop
        itemname AS STRING * 12
        itemtype AS STRING * 12
        strength AS INTEGER
        cost AS INTEGER
END TYPE

TYPE enemy
        hp AS INTEGER
        enname AS STRING * 8
        strength AS INTEGER
        defense AS INTEGER
        evade AS INTEGER
        speed AS INTEGER
        newgold AS INTEGER
        newexp AS INTEGER
        numattacks AS INTEGER
END TYPE
    
TYPE getscrn
        getoff AS INTEGER
        x1 AS INTEGER
        y1 AS INTEGER
        x2 AS INTEGER
        y2 AS INTEGER
END TYPE


COMMON SHARED Tiles() AS INTEGER
COMMON SHARED Tiles2() AS INTEGER
COMMON SHARED Sprites() AS INTEGER
COMMON SHARED NPCSpr() AS INTEGER
COMMON SHARED Undersprite() AS INTEGER
COMMON SHARED BattleChar() AS INTEGER
COMMON SHARED BattleEn() AS INTEGER
COMMON SHARED enemy() AS enemy
COMMON SHARED EnAttacks() AS STRING
COMMON SHARED Battlemagic() AS INTEGER
COMMON SHARED tempsprite() AS INTEGER
COMMON SHARED aniarray() AS INTEGER
COMMON SHARED Aniarray2() AS INTEGER
COMMON SHARED temparray() AS INTEGER
COMMON SHARED battlearray() AS INTEGER
COMMON SHARED battlearray2() AS INTEGER
COMMON SHARED anitemp() AS INTEGER
COMMON SHARED Map() AS INTEGER
COMMON SHARED scrn() AS INTEGER
COMMON SHARED colors() AS rgb
COMMON SHARED Font() AS INTEGER
COMMON SHARED mapchange() AS mapchange
COMMON SHARED NPCs() AS NPC
COMMON SHARED items() AS item
COMMON SHARED magic() AS magic
COMMON SHARED shopitems() AS shop
COMMON SHARED trans() AS INTEGER
COMMON SHARED gets() AS getscrn
COMMON SHARED flags() AS INTEGER

COMMON SHARED numspells AS INTEGER
COMMON SHARED rgbval AS STRING * 1
COMMON SHARED scroll AS STRING
COMMON SHARED xscrn AS INTEGER
COMMON SHARED yscrn AS INTEGER
COMMON SHARED xspr AS INTEGER
COMMON SHARED yspr AS INTEGER
COMMON SHARED nomovetile AS INTEGER
COMMON SHARED xmap AS INTEGER
COMMON SHARED ymap AS INTEGER
COMMON SHARED tilename1 AS STRING
COMMON SHARED tilename2 AS STRING
COMMON SHARED palettename AS STRING
COMMON SHARED maptype AS STRING
COMMON SHARED mapname AS STRING
COMMON SHARED mapfile AS STRING
COMMON SHARED edgemapchange AS edgemapchange
COMMON SHARED mapchanges AS INTEGER
COMMON SHARED numNPCs AS INTEGER
COMMON SHARED scriptfile AS STRING
COMMON SHARED fontname AS STRING
COMMON SHARED xfntsize AS INTEGER
COMMON SHARED yfntsize AS INTEGER
COMMON SHARED btextline AS INTEGER
COMMON SHARED responce AS STRING
COMMON SHARED x AS INTEGER
COMMON SHARED y AS INTEGER
COMMON SHARED direction AS INTEGER
COMMON SHARED charstep AS INTEGER
COMMON SHARED yourname AS STRING
COMMON SHARED hp AS INTEGER
COMMON SHARED maxhp AS INTEGER
COMMON SHARED MP AS INTEGER
COMMON SHARED maxmp AS INTEGER
COMMON SHARED strength AS INTEGER
COMMON SHARED defense AS INTEGER
COMMON SHARED speed AS INTEGER
COMMON SHARED level AS INTEGER
COMMON SHARED Gold AS LONG
COMMON SHARED expoints AS LONG
COMMON SHARED weapon AS weapon
COMMON SHARED armor AS armor
COMMON SHARED shield AS shield
COMMON SHARED bstrength AS INTEGER
COMMON SHARED bdefense AS INTEGER
COMMON SHARED bspeed AS INTEGER
COMMON SHARED evade AS INTEGER
COMMON SHARED enname AS STRING
COMMON SHARED enHP AS INTEGER
COMMON SHARED enstrength AS INTEGER
COMMON SHARED endefense AS INTEGER
COMMON SHARED enspeed AS INTEGER
COMMON SHARED enevade AS INTEGER
COMMON SHARED numattacks AS INTEGER
COMMON SHARED getoff AS INTEGER
COMMON SHARED getnum AS INTEGER

DIM SHARED Tiles(0, 0, 0) AS INTEGER
DIM SHARED Tiles2(0, 0, 0) AS INTEGER
DIM SHARED Sprites(129, 15, 1) AS INTEGER
DIM SHARED NPCSpr(129, 3, 7, 1) AS INTEGER
DIM SHARED Undersprite(129, 0, 0) AS INTEGER
DIM SHARED BattleChar(129, 0, 0) AS INTEGER
DIM SHARED BattleEn(129, 0, 0) AS INTEGER
DIM SHARED enemy(0) AS enemy
DIM SHARED EnAttacks(0, 5) AS STRING
DIM SHARED Battlemagic(129, 4, 1) AS INTEGER
DIM SHARED tempsprite(129, 0, 0) AS INTEGER
DIM SHARED aniarray(0, 0) AS INTEGER
DIM SHARED Aniarray2(0, 0, 0) AS INTEGER
DIM SHARED temparray(129) AS INTEGER
DIM SHARED battlearray(513) AS INTEGER
DIM SHARED battlearray2(513) AS INTEGER
DIM SHARED anitemp(129) AS INTEGER
DIM SHARED Map(0, 0, 0) AS INTEGER
DIM SHARED scrn(32001) AS INTEGER
DIM SHARED colors(255) AS rgb
DIM SHARED Font(0, 0, 0) AS INTEGER
DIM SHARED mapchange(0) AS mapchange
DIM SHARED NPCs(0) AS NPC
DIM SHARED items(39) AS item
DIM SHARED magic(19) AS magic
DIM SHARED shopitems(0) AS shop
DIM SHARED trans(255) AS INTEGER
DIM SHARED gets(9) AS getscrn
DIM SHARED flags(10) AS INTEGER


SCREEN 13
RANDOMIZE TIMER
DEFINT A-Z

drawbox 0, 0, 319, 191, 241, 242, 240
drawbox 7, 7, 312, 184, 0, 240, 242
initvars

DO
        scrolldir$ = ""
        DO
                a = INP(&H60)
        LOOP WHILE a = 0
        IF a = 1 THEN status
        IF a = 72 THEN doscroll "up"
        IF a = 80 THEN doscroll "down"
        IF a = 75 THEN doscroll "left"
        IF a = 77 THEN doscroll "right"
        IF a = 28 THEN '57
                IF maptype <> "world" THEN
                        SELECT CASE direction
                                CASE 0: IF Map(y + 1, x, 2) > 0 THEN NPCinteract x, y + 1
                                CASE 1: IF Map(y, x + 1, 2) > 0 THEN NPCinteract x + 1, y
                                CASE 2: IF Map(y - 1, x, 2) > 0 THEN NPCinteract x, y - 1
                                CASE 3: IF Map(y, x - 1, 2) > 0 THEN NPCinteract x - 1, y
                        END SELECT
                END IF
        END IF
        clrkbuffer
LOOP

REM $STATIC
SUB battle (ennum)

IF ennum = 0 THEN EXIT SUB

bstrength = strength + weapon.strength
bdefense = defense + armor.defense
bspeed = speed
evade = shield.evade
defending = 0

enname = RTRIM$(enemy(ennum).enname)
enHP = enemy(ennum).hp
enstrength = enemy(ennum).strength
endefense = enemy(ennum).defense
enspeed = enemy(ennum).speed
enevade = enemy(ennum).evade
numattacks = enemy(ennum).numattacks

attackbar# = 0
enattackbar# = 0

btextline = 0

bweapon$ = RTRIM$(weapon.weaponname)
IF bweapon$ = CHR$(0) THEN bweapon$ = "your hands"

barmor$ = RTRIM$(armor.armorname)
IF barmor$ = CHR$(0) THEN barmor$ = "your skin"

bshield$ = RTRIM$(shield.shieldname)
IF bshield$ = CHR$(0) THEN bshield$ = "nothing"


REDIM enback(5001) AS INTEGER
DEF SEG = VARSEG(enback(0))
BLOAD "rpgdemo\gfx\battleb.put", 0
DEF SEG

OPEN "rpgdemo\gfx\battle.put" FOR BINARY AS 1
Ints = (LOF(1) - 15) / 2
numtiles = Ints / 513 / 2 - 1
CLOSE 1
REDIM BattleChar(513, numtiles, 1) AS INTEGER
DEF SEG = VARSEG(BattleChar(0, 0, 0))
BLOAD "rpgdemo\gfx\battle.put", 0
DEF SEG

OPEN "rpgdemo\gfx\" + enname + ".put" FOR BINARY AS 1
Ints = (LOF(1) - 15) / 2
numtiles = Ints / 513 / 2 - 1
CLOSE 1
REDIM BattleEn(513, numtiles, 1) AS INTEGER
DEF SEG = VARSEG(BattleEn(0, 0, 0))
BLOAD "rpgdemo\gfx\" + enname + ".put", 0
DEF SEG

REDIM Battlemagic(129, 11, 1) AS INTEGER
DEF SEG = VARSEG(Battlemagic(0, 0, 0))
BLOAD "rpgdemo\tiles\batmagic.put", 0
DEF SEG


getscrn 46, 18, 147, 119
getscrn 191, 16, 303, 50
getscrn 191, 58, 303, 121
getscrn 16, 132, 303, 175
bevelbox 46, 18, 147, 119, 241, 242, 240, 0
bevelbox 191, 16, 303, 50, 241, 242, 240, 0
bevelbox 191, 58, 303, 121, 241, 242, 240, 0
bevelbox 16, 132, 303, 175, 241, 242, 240, 0

showfont 196, 21, 31, "HP:", 1, 1
showfont 208, 21, 171, STR$(hp) + "/" + LTRIM$(STR$(maxhp)), 1, 1
drawbox 196, 29, 298, 31, 0, 254, 252
LINE (197, 30)-(197 + 100 * (hp / maxhp), 30), 253
showfont 196, 35, 31, "MP:", 1, 1
showfont 208, 35, 171, STR$(MP) + "/" + LTRIM$(STR$(maxmp)), 1, 1
drawbox 196, 43, 298, 45, 0, 254, 252
LINE (197, 44)-(197 + 100 * (MP / maxmp), 44), 253


drawbox 196, 63, 298, 65, 0, 246, 244

PUT (49, 21), enback, PSET

GET (54, 66)-(54 + 31, 66 + 31), battlearray
PUT (54, 66), BattleChar(0, 0, 1), AND
PUT (54, 66), BattleChar(0, 0, 0), OR
GET (108, 66)-(108 + 31, 66 + 31), battlearray2
PUT (108, 66), BattleEn(0, 0, 1), AND
PUT (108, 66), BattleEn(0, 0, 0), OR

showfont 202, 77, 31, "Attack", 1, 1
showfont 202, 84, 31, "Magic", 1, 1
showfont 202, 91, 31, "Item", 1, 1
showfont 202, 98, 31, "Defend", 1, 1
showfont 202, 105, 31, "Run", 1, 1
           
DO
        pause .001
        attackbar# = attackbar# + bspeed / 8
        IF attackbar# > 100 THEN attackbar# = 100
        enattackbar# = enattackbar# + enspeed / 8
        IF enattackbar# > 100 THEN enattackbar# = 100
        LINE (197, 64)-(197 + attackbar#, 64), 245
        IF attackbar# = 100 THEN
                IF defending = 1 THEN
                        bdefense = bdefense / 2
                        evade = evade / 2
                        defending = 0
                END IF
                attackbar# = 0
                action = 0
                DO
                        SELECT CASE action
                                CASE 0: showfont 202, 77, 95, "Attack", 1, 1
                                CASE 1: showfont 202, 84, 95, "Magic", 1, 1
                                CASE 2: showfont 202, 91, 95, "Item", 1, 1
                                CASE 3: showfont 202, 98, 95, "Defend", 1, 1
                                CASE 4: showfont 202, 105, 95, "Run", 1, 1
                        END SELECT
                        DO
                                a$ = INKEY$
                        LOOP UNTIL a$ <> ""
                        SELECT CASE action
                                CASE 0: showfont 202, 77, 31, "Attack", 1, 1
                                CASE 1: showfont 202, 84, 31, "Magic", 1, 1
                                CASE 2: showfont 202, 91, 31, "Item", 1, 1
                                CASE 3: showfont 202, 98, 31, "Defend", 1, 1
                                CASE 4: showfont 202, 105, 31, "Run", 1, 1
                        END SELECT
                        IF a$ = CHR$(0) + "H" AND action > 0 THEN action = action - 1
                        IF a$ = CHR$(0) + "P" AND action < 4 THEN action = action + 1
                        IF a$ = " " THEN
                                IF action = 0 THEN
                                        playani "attack.put", 54, 66, 32, 32, .1
                                        IF RND * 100 > enevade THEN
                                                damage = bstrength + INT(RND * bstrength / 4) - endefense
                                                IF damage < 0 THEN damage = 0
                                                battletext "You attack with " + bweapon$ + " for" + STR$(damage) + " damage"
                                                enHP = enHP - damage
                                                IF enHP <= 0 THEN
                                                        inkey
                                                        battletext "You have defeated the " + enname + "!"
                                                        ngold = enemy(ennum).newgold
                                                        nexp = enemy(ennum).newexp
                                                        Gold = Gold + ngold
                                                        expoints = expoints + nexp
                                                        battletext "You gained" + STR$(nexp) + " EXP"
                                                        battletext "and recieved" + STR$(ngold) + " gold!"
                                                        battletext ""
                                                        IF expoints >= 10 * 2 ^ level THEN
                                                                battletext "You gained a level!"
                                                                inkey
                                                                level = level + 1
                                                                nhp = INT(RND * 10) + 1
                                                                nmp = INT(RND * 5) + 1
                                                                nstr = INT(RND * 3) + 1
                                                                ndef = INT(RND * 3) + 1
                                                                nspd = INT(RND * 3)
                                                                maxhp = maxhp + nhp
                                                                maxmp = maxmp + nmp
                                                                strength = strength + nstr
                                                                defense = defense + ndef
                                                                speed = speed + nspd
                                                                battletext "You gained" + STR$(nhp) + " hit points"
                                                                battletext "You gained" + STR$(nmp) + " magic points"
                                                                battletext "Your strength went up" + STR$(nstr)
                                                                battletext "Your defense went up" + STR$(ndef)
                                                                IF nspd THEN
                                                                        battletext "Your speed went up" + STR$(nspd)
                                                                ELSE
                                                                        battletext ""
                                                                END IF
                                                                FOR spell = 0 TO numspells
                                                                        IF magic(spell).level = level THEN
                                                                                magic(spell).learned = 1
                                                                                inkey
                                                                                battletext "And you learned a new spell!"
                                                                                battletext ""
                                                                                battletext ""
                                                                                battletext ""
                                                                                battletext ""
                                                                        END IF
                                                                NEXT

                                                        ELSE
                                                                battletext ""
                                                        END IF
                                                        inkey
                                                        putscrn 0, 0
                                                        putscrn 0, 0
                                                        putscrn 0, 0
                                                        putscrn 0, 0
                                                        EXIT SUB
                                                END IF
                                        ELSE
                                                playani enname + "b.put", 108, 66, 32, 32, .1
                                                battletext "The " + enname + " blocked your attack!"
                                                PUT (54, 66), battlearray, PSET
                                                PUT (54, 66), BattleChar(0, 0, 1), AND
                                                PUT (54, 66), BattleChar(0, 0, 0), OR
                                        END IF
                                        pause .5
                                        PUT (54, 66), battlearray, PSET
                                        PUT (54, 66), BattleChar(0, 0, 1), AND
                                        PUT (54, 66), BattleChar(0, 0, 0), OR
                                END IF
                                IF action = 1 THEN
                                        showmagic 1
                                END IF
                                IF action = 2 THEN
                                        showitems 1
                                END IF
                                IF action = 3 THEN
                                        defending = 1
                                        bdefense = bdefense * 2
                                        evade = evade * 2
                                        battletext "You defend with " + bshield$
                                        pause .5
                                END IF
                                IF action = 4 THEN
                                        playani "run.put", 54, 66, 32, 32, .1
                                        battletext "You ran away"
                                        inkey
                                        putscrn 0, 0
                                        putscrn 0, 0
                                        putscrn 0, 0
                                        putscrn 0, 0
                                        EXIT SUB
                                END IF
                                EXIT DO
                        END IF
                LOOP
                LINE (197, 64)-(297, 64), 0
        END IF
        IF enattackbar# = 100 THEN
                enattackbar# = 0
                attackname$ = LCASE$(LTRIM$(EnAttacks(ennum, INT(RND * numattacks) + 1)))
                enattack attackname$
        END IF
LOOP

END SUB

SUB battletext (text$)


IF btextline = 5 THEN
        FOR scrl = 1 TO 7
                movescrn 21, 138, 298, 170, 0, -1
                LINE (21, 171 - scrl)-(298, 171 - scrl), 0, BF
        NEXT
        btextline = btextline - 1
END IF
showfont 21, 137 + 7 * btextline, 31, text$, 1, 1
btextline = btextline + 1

END SUB

SUB bevelbox (x1, y1, x2, y2, col, shade1, shade2, fill)

LINE (x1 + 1, y1 + 1)-(x2 - 1, y2 - 1), col, B
IF fill > -1 THEN LINE (x1 + 3, y1 + 3)-(x2 - 3, y2 - 3), fill, BF
LINE (x1, y1)-(x2 - 1, y1), shade1
LINE (x1, y1)-(x1, y2), shade1
LINE (x2, y2)-(x1 + 1, y2), shade2
LINE (x2, y2)-(x2, y1), shade2
LINE (x1 + 2, y1 + 2)-(x2 - 3, y1 + 2), shade2
LINE (x1 + 2, y1 + 2)-(x1 + 2, y2 - 2), shade2
LINE (x2 - 2, y2 - 2)-(x1 + 3, y2 - 2), shade1
LINE (x2 - 2, y2 - 2)-(x2 - 2, y1 + 2), shade1

END SUB

SUB changemap

IF x = 0 OR x = xmap - 1 OR y = 0 OR y = ymap - 1 THEN
        x = edgemapchange.x
        y = edgemapchange.y
        mapchangename$ = edgemapchange.mapname
        loadmap mapchangename$
        showscreen (1)
        EXIT SUB
END IF
IF mapchanges > 0 THEN
        FOR mapchange = 0 TO mapchanges - 1
                IF x = mapchange(mapchange).x AND y = mapchange(mapchange).y THEN
                        x = mapchange(mapchange).newx
                        y = mapchange(mapchange).newy
                        mapchangename$ = mapchange(mapchange).mapname
                        loadmap mapchangename$
                        showscreen (1)
                        EXIT SUB
                END IF
        NEXT
END IF

END SUB

SUB clearscreen (mode)

IF mode = 1 THEN
        xstp = 1
        ystp = 4
        clrdir = -1
        FOR yclr = ystp TO 175 STEP ystp
                clrdir = -1
                FOR xclr = 8 TO 311 STEP xstp
                        IF clrdir = -1 THEN
                                LINE (xclr, 183 - yclr)-(xclr + xstp - 1, 183 - yclr + ystp), 0, BF
                        ELSE
                                LINE (xclr, 8 + yclr)-(xclr + xstp - 1, 8 + yclr - ystp), 0, BF
                        END IF
                        clrdir = -clrdir
                NEXT
        NEXT
END IF
IF mode = 2 THEN
        maxsize = 16
        FOR clrsize = maxsize / 2 TO 0 STEP -1
                FOR yclr = 8 TO 184 - maxsize STEP maxsize
                        FOR xclr = 8 TO 312 - maxsize STEP maxsize
                                LINE (xclr + clrsize, yclr + clrsize)-(xclr + maxsize - clrsize - 1, yclr + maxsize - clrsize - 1), 0, BF
                        NEXT
                NEXT
                pause .1
        NEXT
END IF
IF mode = 4 THEN
        FOR clr = 0 TO 87 STEP .025
                LINE (8 + clr, 8 + clr)-(311 - clr, 183 - clr), 0, B
        NEXT
END IF


END SUB

SUB clrkbuffer
DEF SEG = &H40
POKE &H1A, PEEK(&H1C)
END SUB

SUB doenattack (attackname$, damage)

IF damage > 0 THEN
        'playani "attacked.put", 54, 66, 32, 32, .1
        battletext "The " + enname + " " + attackname$ + " for" + STR$(damage) + " damage"
        'PUT (54, 66), battlearray, PSET
        'PUT (54, 66), BattleChar(0, 0, 1), AND
        'PUT (54, 66), BattleChar(0, 0, 0), OR
        hp = hp - damage
        IF hp < 0 THEN hp = 0
        LINE (208, 21)-(250, 26), 0, BF
        showfont 208, 21, 171, STR$(hp) + "/" + LTRIM$(STR$(maxhp)), 1, 1
        LINE (197, 30)-(297, 30), 0
        LINE (197, 30)-(197 + 100 * (hp / maxhp), 30), 253
        IF hp = 0 THEN
                inkey
                battletext ""
                battletext ""
                battletext "You have been defeated by the " + enname + "!"
                battletext ""
                battletext ""
                inkey
                endgame
        END IF
ELSE
        battletext "The " + enname + " " + attackname$ + "... but misses!"
END IF


END SUB

SUB doitem (item, text$)

items(item).itemname = CHR$(0)
items(item).itemtype = CHR$(0)
items(item).strength = 0
items(item).cost = 0

getscrn 16, 146, 303, 175
bevelbox 16, 146, 303, 175, 241, 242, 240, 0
showfont 21, 151, 31, text$, 1, 1
inkey
putscrn 0, 0

END SUB

SUB doscript (scriptname$, scriptnum)

OPEN "rpgdemo\dat\" + scriptname$ FOR INPUT AS 2

DO
        DO
                LINE INPUT #2, script$
                script$ = LCASE$(script$)
        LOOP UNTIL INSTR(script$, "start")
        scriptnum2 = VAL(RIGHT$(script$, LEN(script$) - 5))
LOOP UNTIL scriptnum2 = scriptnum

readscript

CLOSE 2

END SUB

SUB doscroll (scrolldir$)

IF maptype <> "world" THEN
        IF scrolldir$ = "up" AND y = 0 THEN EXIT SUB
        IF scrolldir$ = "down" AND y = ymap - 1 THEN EXIT SUB
        IF scrolldir$ = "left" AND x = 0 THEN EXIT SUB
        IF scrolldir$ = "right" AND x = xmap - 1 THEN EXIT SUB
END IF

x2 = x
y2 = y
SELECT CASE scrolldir$
        CASE "up":
                y2 = y - 1
                IF y2 < 0 THEN y2 = y2 + ymap
                direction = 2
        CASE "down":
                y2 = y + 1
                IF y2 >= ymap THEN y2 = y2 - ymap
                direction = 0
        CASE "left":
                x2 = x - 1
                IF x2 < 0 THEN x2 = x2 + xmap
                direction = 3
        CASE "right":
                x2 = x + 1
                IF x2 >= xmap THEN x2 = x2 - xmap
                direction = 1
        CASE ELSE:
                EXIT SUB
END SELECT
tile = Map(y2, x2, 0)
IF maptype <> "world" THEN NPC = Map(y2, x2, 2) ELSE NPC = 0
charstep = charstep + 1
IF charstep = 4 THEN charstep = 0
IF tile >= nomovetile OR NPC > 0 THEN
        pastearray 0, 0, Undersprite(), temparray(), 0
        pastearray 0, 0, Sprites(), temparray(), 4 * direction + charstep
        IF maptype <> "world" THEN
                IF Map(y, x, 1) > 0 THEN
                        tile% = Map(y, x, 1) - 1
                        pastearray 0, 0, Tiles2(), temparray(), tile%
                END IF
        END IF
        PUT (xspr, yspr), temparray, PSET
        EXIT SUB
END IF

xg1 = 8
xg2 = 8 + 32 * xscrn + 15
xp = 8
x2 = 0
yg1 = 8
yg2 = 8 + 32 * yscrn + 15
yp = 8
y2 = 0
SELECT CASE scrolldir$
        CASE "up":
                y = y - 1
                IF y < 0 THEN y = y + ymap
                yg2 = yg2 - 16
                yp = yp + 16
                yt = 8
                ym = y - yscrn
                IF ym < 0 AND maptype = "world" THEN ym = ym + ymap
                IF ym < 0 AND maptype = "town" THEN ym = 0
                x2 = 1
        CASE "down":
                y = y + 1
                IF y >= ymap THEN y = y - ymap
                yg1 = yg1 + 16
                yt = 32 * yscrn + 8
                ym = y + yscrn
                IF ym >= ymap AND maptype = "world" THEN ym = ym - ymap
                IF ym >= ymap AND maptype = "town" THEN ym = ymap - 1
                x2 = 1
        CASE "left":
                x = x - 1
                IF x < 0 THEN x = x + xmap
                xg2 = xg2 - 16
                xp = xp + 16
                xt = 8
                xm = x - xscrn
                IF xm < 0 AND maptype = "world" THEN xm = xm + xmap
                IF xm < 0 AND maptype = "town" THEN xm = 0
                y2 = 1
        CASE "right":
                x = x + 1
                IF x >= xmap THEN x = x - xmap
                xg1 = xg1 + 16
                xt = 32 * xscrn + 8
                xm = x + xscrn
                IF xm >= xmap AND maptype = "world" THEN xm = xm - xmap
                IF xm >= xmap AND maptype = "town" THEN xm = xmap - 1
                y2 = 1
END SELECT

GET (xg1, yg1)-(xg2, yg2), scrn
pastearray xspr - xg1, yspr - yg1, Undersprite(), scrn(), 0
extractarray xspr - xp, yspr - yp, Undersprite(), scrn()
pastearray xspr - xp, yspr - yp, Sprites(), scrn(), 4 * direction + charstep
IF maptype <> "world" THEN
        IF Map(y, x, 1) > 0 THEN
                tile% = Map(y, x, 1) - 1
                pastearray xspr - xp, yspr - yp, Tiles2(), scrn(), tile%
        END IF
END IF
PUT (xp, yp), scrn, PSET

IF x2 > 0 THEN
        FOR x2 = x - xscrn TO x + xscrn
                x3 = x2
                xt = 16 * (x2 - x + xscrn) + 8
                IF maptype = "world" THEN
                        IF x3 < 0 THEN x3 = x3 + xmap
                        IF x3 >= xmap THEN x3 = x3 - xmap
                        tile = Map(ym, x3, 0)
                        PUT (xt, yt), Tiles(0, tile, 0), PSET
                ELSE
                        IF maptype = "town" THEN
                                IF x3 < 0 THEN x3 = 0
                                IF x3 >= xmap THEN x3 = xmap - 1
                        END IF
                        IF x3 < 0 OR x3 >= xmap OR ym < 0 OR ym >= ymap THEN
                                LINE (xt, yt)-(xt + 15, yt + 15), 0, BF
                        ELSE
                                tile = Map(ym, x3, 0)
                                PUT (xt, yt), Tiles(0, tile, 0), PSET
                                IF Map(ym, x3, 2) > 0 THEN
                                        NPC = Map(ym, x3, 2)
                                        NPCshow NPC
                                END IF
                                IF ym < ymap - 1 THEN
                                        IF Map(ym + 1, x3, 2) > 0 THEN
                                                NPC = Map(ym + 1, x3, 2)
                                                NPCshow NPC
                                        END IF
                                END IF
                                IF Map(ym, x3, 1) > 0 THEN
                                        tile = Map(ym, x3, 1) - 1
                                        PUT (xt, yt), Tiles2(0, tile, 1), AND
                                        PUT (xt, yt), Tiles2(0, tile, 0), OR
                                END IF
                        END IF
                END IF
        NEXT
END IF
IF y2 > 0 THEN
        FOR y2 = y - yscrn TO y + yscrn
                y3 = y2
                yt = 16 * (y2 - y + yscrn) + 8
                IF maptype = "world" THEN
                        IF y3 < 0 THEN y3 = y3 + ymap
                        IF y3 >= ymap THEN y3 = y3 - ymap
                        tile = Map(y3, xm, 0)
                        PUT (xt, yt), Tiles(0, tile, 0), PSET
                ELSE
                        IF maptype = "town" THEN
                                IF y3 < 0 THEN y3 = 0
                                IF y3 >= ymap THEN y3 = ymap - 1
                        END IF
                        IF xm < 0 OR xm >= xmap OR y3 < 0 OR y3 >= xmap THEN
                                LINE (xt, yt)-(xt + 15, yt + 15), 0, BF
                        ELSE
                                tile = Map(y3, xm, 0)
                                PUT (xt, yt), Tiles(0, tile, 0), PSET
                                IF Map(y3, xm, 2) > 0 THEN
                                        NPC = Map(y3, xm, 2)
                                        NPCshow NPC
                                END IF
                                IF y3 < ymap - 1 THEN
                                        IF Map(y3 + 1, xm, 2) > 0 THEN
                                                NPC = Map(y3 + 1, xm, 2)
                                                NPCshow NPC
                                        END IF
                                END IF
                                IF Map(y3, xm, 1) > 0 THEN
                                        tile = Map(y3, xm, 1) - 1
                                        PUT (xt, yt), Tiles2(0, tile, 1), AND
                                        PUT (xt, yt), Tiles2(0, tile, 0), OR
                                END IF
                        END IF
                END IF
        NEXT
END IF

changemap

IF maptype = "world" AND RND > .9 THEN battle (Map(y, x, 1))

END SUB

SUB dotrans (x1%, y1%, x2%, y2%)

'DEF SEG = &HA000
FOR xtrans% = x1% TO x2%
        FOR ytrans% = y1% TO y2%
                'col% = PEEK(xtrans% + ytrans% * 320&)
                col% = POINT(xtrans%, ytrans%)
                col2% = trans(col%)
                PSET (xtrans%, ytrans%), col2%
                'POKE (xtrans% + ytrans% * 320&), col%
                'PRINT col%
        NEXT
NEXT
'DEF SEG

END SUB

SUB drawbox (x1, y1, x2, y2, col, shade1, shade2)


LINE (x1 + 1, y1 + 1)-(x2 - 1, y2 - 1), col, BF
LINE (x1, y1)-(x2 - 1, y1), shade1
LINE (x1, y1)-(x1, y2), shade1
LINE (x2, y2)-(x1 + 1, y2), shade2
LINE (x2, y2)-(x2, y1), shade2

END SUB

SUB enattack (attackname$)

playani enname + "a.put", 108, 66, 32, 32, .1

SELECT CASE attackname$
        CASE "slash"
                IF RND * 100 > evade THEN
                        IF RND < .9 THEN
                                damage = .75 * enstrength - bdefense
                        ELSE
                                damage = 0
                        END IF
                        IF damage < 0 THEN damage = 0
                        doenattack "slashes", damage
                ELSE
                        playani "block.put", 54, 66, 32, 32, .1
                        battletext "You blocked the " + enname + "'s attack!"
                        PUT (54, 66), battlearray, PSET
                        PUT (54, 66), BattleChar(0, 0, 1), AND
                        PUT (54, 66), BattleChar(0, 0, 0), OR
                END IF
        CASE "thrust"
                IF RND * 100 > evade THEN
                        IF RND < .6 THEN
                                damage = enstrength - bdefense
                        ELSE
                                damage = 0
                        END IF
                        IF damage < 0 THEN damage = 0
                        doenattack "thrusts", damage
                ELSE
                        playani "block.put", 54, 66, 32, 32, .1
                        battletext "You blocked the " + enname + "'s attack!"
                        PUT (54, 66), battlearray, PSET
                        PUT (54, 66), BattleChar(0, 0, 1), AND
                        PUT (54, 66), BattleChar(0, 0, 0), OR
                END IF
        CASE "fire"
                damage = enstrength + INT(RND * enstrength)
                IF damage < 0 THEN damage = 0
                playani2 Battlemagic(), 0, 1, 57, 30, 0, 2, 15, .0001
                doenattack "casts Fire", damage
        CASE "fireball"
                damage = enstrength + INT(RND * enstrength)
                IF damage < 0 THEN damage = 0
                playani2 Battlemagic(), 0, 1, 57, 30, 0, 2, 15, .0001
                doenattack "casts Fireball", damage
        CASE "ice"
                damage = enstrength + INT(RND * enstrength)
                IF damage < 0 THEN damage = 0
                playani2 Battlemagic(), 6, 9, 57, 30, 0, 2, 15, .0001
                doenattack "casts Ice", damage
        CASE "lightning"
                damage = enstrength + INT(RND * enstrength)
                IF damage < 0 THEN damage = 0
                playani2 Battlemagic(), 2, 5, 57, 30, 0, 2, 15, .0001
                doenattack "casts Lightning", damage
        CASE "bow"
                IF RND * 100 > evade THEN
                        damage = enstrength + INT(RND * enstrength) - bdefense
                        IF damage < 0 THEN damage = 0
                        doenattack "attacks with Bow", damage
                ELSE
                        battletext "The " + enname + "missed!"
                END IF
        CASE "longbow"
                IF RND * 100 > evade THEN
                        damage = enstrength + INT(RND * enstrength) - bdefense
                        IF damage < 0 THEN damage = 0
                        doenattack "attacks with Longbow", damage
                ELSE
                        battletext "The " + enname + "missed!"
                END IF
END SELECT

pause .5
PUT (108, 66), battlearray2, PSET
PUT (108, 66), BattleEn(0, 0, 1), AND
PUT (108, 66), BattleEn(0, 0, 0), OR


END SUB

SUB endgame

CHDIR "C:\dos\"
END
END SUB

SUB extractarray (xextract%, yextract%, array1%(), array2%())

xsize1 = array1%(0, 0, 0) / 8
ysize1 = array1%(1, 0, 0)
xsize2 = array2%(0) / 8
ysize2 = array2%(1)

FOR yextract2 = yextract% TO yextract% + ysize1 - 1
        FOR xextract2 = xextract% TO xextract% + xsize1 - 1
                clipspace1! = 2 + (xsize1 * (yextract2 - yextract%) + (xextract2 - xextract%)) / 2
                cliparray1 = INT(clipspace1!)
                clipspace2! = 2 + (xsize2 * yextract2 + xextract2) / 2
                cliparray2 = INT(clipspace2!)
                IF clipspace2! = cliparray2 THEN
                        colour1 = array2%(cliparray2) - 256 * INT(array2%(cliparray2) / 256)
                ELSE
                        colour1 = INT(array2%(cliparray2) / 256)
                END IF
                IF clipspace1! = cliparray1 THEN
                        array1%(cliparray1, 0, 0) = colour1 + 256 * INT(array1%(cliparray1, 0, 0) / 256)
                ELSE
                        array1%(cliparray1, 0, 0) = colour1 * 256& + array1%(cliparray1, 0, 0) - 256& * INT(array1%(cliparray1, 0, 0) / 256)
                END IF
        NEXT
NEXT

END SUB

SUB fadein (col1%, col2%)

FOR fadestep% = 63 TO 0 STEP -1
        FOR col% = col1% TO col2%
                r% = colors(col%).r
                g% = colors(col%).g
                B% = colors(col%).B
                r1% = r% - fadestep% * r% / 63
                g1% = g% - fadestep% * g% / 63
                b1% = B% - fadestep% * B% / 63
                pal col%, r1%, g1%, b1%
        NEXT
NEXT

END SUB

SUB fadeout (col1%, col2%)

FOR fadestep% = 0 TO 63
        FOR col% = col1% TO col2%
                r% = colors(col%).r
                g% = colors(col%).g
                B% = colors(col%).B
                r1% = r% - fadestep% * r% / 63
                g1% = g% - fadestep% * g% / 63
                b1% = B% - fadestep% * B% / 63
                pal col%, r1%, g1%, b1%
        NEXT
NEXT

END SUB

SUB getscrn (x1, y1, x2, y2)

gets(getnum).getoff = getoff
gets(getnum).x1 = x1
gets(getnum).y1 = y1
gets(getnum).x2 = x2
gets(getnum).y2 = y2
GET (x1, y1)-(x2, y2), scrn(getoff)

getoff = getoff + CINT((x2 - x1 + 1) * (y2 - y1 + 1) / 2 + 3)
getnum = getnum + 1

END SUB

SUB growbevelbox (x1, y1, x2, y2, col, shade1, shade2, steps)

midx = (x1 + x2) / 2
midy = (y1 + y2) / 2
xstp = ((x2 - x1) / 2) / steps
ystp = ((y2 - y1) / 2) / steps
FOR box = 1 TO steps
        bevelbox midx - box * xstp, midy - box * ystp, midx + box * xstp, midy + box * ystp, col, shade1, shade2, 0
NEXT


END SUB

SUB growbox (x1, y1, x2, y2, col, shade1, shade2, steps)

midx = (x1 + x2) / 2
midy = (y1 + y2) / 2
xstp = ((x2 - x1) / 2) / steps
ystp = ((y2 - y1) / 2) / steps
FOR box = 1 TO steps
        drawbox midx - box * xstp, midy - box * ystp, midx + box * xstp, midy + box * ystp, col, shade1, shade2
NEXT

END SUB

SUB initvars

xscrn = 9
yscrn = 5
xspr = 16 * xscrn + 8
yspr = 16 * yscrn + 8
direction = 1
charstep = 0

tempsprite(0, 0, 0) = 128
tempsprite(1, 0, 0) = 16
temparray(0) = 128
temparray(1) = 16

maxhp = 50
hp = maxhp
maxmp = 10
MP = maxmp
strength = 10
defense = 3
speed = 5

Gold = 0
expoints = 0
level = 1
weapon.weaponname = CHR$(0)
armor.armorname = CHR$(0)
shield.shieldname = CHR$(0)

yourname = "Entropy"

magic(0).spellname = "Heal":   magic(0).learned = 1: magic(0).useoutofbattle = 1
magic(1).spellname = "Hurt":   magic(1).learned = 1: magic(1).useoutofbattle = 0
magic(2).spellname = "Slow":   magic(2).learned = 1: magic(2).useoutofbattle = 1
magic(3).spellname = "Haste":  magic(3).learned = 1: magic(3).useoutofbattle = 0
magic(4).spellname = "Weak":   magic(4).learned = 1: magic(4).useoutofbattle = 1
magic(5).spellname = "Strong": magic(5).learned = 1: magic(5).useoutofbattle = 0
magic(6).spellname = "Death":  magic(6).learned = 1: magic(6).useoutofbattle = 1
fontname = "rpgdemo.fnt"

loaden "enstat.en"
loadmagic "magic.dat"
loadfont fontname
loadpalette "rpgdemo.pal"
loadsprite "rpgdemos.put", Sprites()
loadsprite2 "npcspr.put", NPCSpr()

doscript "intro.scr", 1

END SUB

SUB inkey
DO
LOOP WHILE INKEY$ = ""
clrkbuffer
END SUB

