'$DYNAMIC

DECLARE SUB battle (ennum%)
DECLARE SUB battletext (text$)
DECLARE SUB bevelbox (x1%, y1%, x2%, y2%, col%, shade1%, shade2%, fill%)
DECLARE SUB changemap ()
DECLARE SUB clearscreen (mode%)
DECLARE SUB clrkbuffer ()
DECLARE SUB doscroll (scrolldir$)
DECLARE SUB doenattack (attackname$, damage%)
DECLARE SUB doitem (item%, text$)
DECLARE SUB doscript (scriptname$, scriptnum%)
DECLARE SUB dotrans (x1%, y1%, x2%, y2%)
DECLARE SUB drawbox (x1%, y1%, x2%, y2%, col%, shade1%, shade2%)
DECLARE SUB enattack (attackname$)
DECLARE SUB endgame ()
DECLARE SUB extractarray (xextract%, yextract%, array1%(), array2%())
DECLARE SUB fadeout (col1%, col2%)
DECLARE SUB fadein (col1%, col2%)
DECLARE SUB getscrn (x1%, y1%, x2%, y2%)
DECLARE SUB bevelbox (x1%, y1%, x2%, y2%, col%, shade1%, shade2%, steps%)
DECLARE SUB box (x1%, y1%, x2%, y2%, col%, shade1%, shade2%, steps%)
DECLARE SUB initvars ()
DECLARE SUB inkey ()
DECLARE SUB inn (price%)
DECLARE SUB inputstring (xfnt%, yfnt%, colour%, text$, var$, maxlength%, xshade%, yshade%, bgcolor%)
DECLARE SUB inputvar (xfnt%, yfnt%, colour%, text$, var%, maxlength%, xshade%, yshade%, bgcolor%)
DECLARE SUB itemnamesort ()
DECLARE SUB itemtypesort ()
DECLARE SUB loaden (file$)
DECLARE SUB loadfont (filename$)
DECLARE SUB loadmagic (file$)
DECLARE SUB loadmap (filename$)
DECLARE SUB loadpalette (filename$)
DECLARE SUB loadshop (shopname$, numitems%)
DECLARE SUB loadsprite (file$, Spritearray%())
DECLARE SUB loadsprite2 (file$, Spritearray%())
DECLARE SUB loadtiles1 (tilename$)
DECLARE SUB loadtiles2 (tilename$)
DECLARE SUB movescrn (x1%, y1%, x2%, y2%, xoff%, yoff%)
DECLARE SUB NPCinteract (interx%, intery%)
DECLARE SUB NPCmove (NPC%, direction%)
DECLARE SUB NPCshow (NPC%)
DECLARE SUB pal (colour%, r%, g%, b%)
DECLARE SUB pastearray (xpaste%, ypaste%, array1%(), array2%(), tilenum%)
DECLARE SUB pause (seconds#)
DECLARE SUB playani (file$, anix%, aniy%, xsize%, ysize%, delay#)
DECLARE SUB playani2 (aniarray%(), tilenum1%, tilenum2%, anix%, aniy%, xchng%, ychng%, frames%, delay#)
DECLARE SUB putscrn (xoff%, yoff%)
DECLARE SUB question (speaker$, text$)
DECLARE SUB readscript ()
DECLARE SUB settrans ()
DECLARE SUB shop (shopname$)
DECLARE SUB showequip ()
DECLARE SUB showfont (xfnt%, yfnt%, colour%, text$, shadex%, shadey%)
DECLARE SUB showitems (inbattle%)
DECLARE SUB showmagic (inbattle%)
DECLARE SUB showload (loaded%)
DECLARE SUB showquit ()
DECLARE SUB showsave ()
DECLARE SUB showscreen (fade%)
DECLARE SUB showstats ()
DECLARE SUB skipscript ()
DECLARE SUB status ()
DECLARE SUB textbox (speaker$, text$)
DECLARE SUB transbox (x1%, y1%, x2%, y2%, col%, shade1%, shade2%)
DECLARE SUB useitem (item%, inbattle%)
DECLARE SUB usemagic (spell%, inbattle%)
DECLARE SUB wingame ()

TYPE rgb
        r AS INTEGER
        g AS INTEGER
        b AS INTEGER
END TYPE

TYPE mapchange
        x AS INTEGER
        y AS INTEGER
        mapname AS STRING * 12
        newx AS INTEGER
        newy AS INTEGER
END TYPE

TYPE edgemapchange
        mapname AS STRING * 12
        x AS INTEGER
        y AS INTEGER
END TYPE

TYPE NPC
        x AS INTEGER
        y AS INTEGER
        NPCname AS STRING * 12
        spriteset AS INTEGER
        direction AS INTEGER
        scriptnum AS INTEGER
END TYPE

TYPE item
        itemname AS STRING * 12
        itemtype AS STRING * 12
        strength AS INTEGER
        cost AS INTEGER
END TYPE

TYPE magic
        spellname AS STRING * 12
        level AS INTEGER
        cost AS INTEGER
        hitpercent AS INTEGER
        useoutofbattle AS INTEGER
        learned AS INTEGER
END TYPE

TYPE weapon
        weaponname AS STRING * 12
        strength AS INTEGER
END TYPE

TYPE armor
        armorname AS STRING * 12
        defense AS INTEGER
END TYPE

TYPE shield
        shieldname AS STRING * 12
        evade AS INTEGER
END TYPE

TYPE shop
        itemname AS STRING * 12
        itemtype AS STRING * 12
        strength AS INTEGER
        cost AS INTEGER
END TYPE

TYPE enemy
        hp AS INTEGER
        enname AS STRING * 8
        strength AS INTEGER
        defense AS INTEGER
        evade AS INTEGER
        speed AS INTEGER
        newgold AS INTEGER
        newexp AS INTEGER
        numattacks AS INTEGER
END TYPE
   
TYPE getscrn
        getoff AS INTEGER
        x1 AS INTEGER
        y1 AS INTEGER
        x2 AS INTEGER
        y2 AS INTEGER
END TYPE


COMMON SHARED Tiles() AS INTEGER
COMMON SHARED Tiles2() AS INTEGER
COMMON SHARED Sprites() AS INTEGER
COMMON SHARED NPCSpr() AS INTEGER
COMMON SHARED Undersprite() AS INTEGER
COMMON SHARED BattleChar() AS INTEGER
COMMON SHARED BattleEn() AS INTEGER
COMMON SHARED enemy() AS enemy
COMMON SHARED EnAttacks() AS STRING
COMMON SHARED Battlemagic() AS INTEGER
COMMON SHARED tempsprite() AS INTEGER
COMMON SHARED aniarray() AS INTEGER
COMMON SHARED Aniarray2() AS INTEGER
COMMON SHARED temparray() AS INTEGER
COMMON SHARED battlearray() AS INTEGER
COMMON SHARED battlearray2() AS INTEGER
COMMON SHARED anitemp() AS INTEGER
COMMON SHARED Map() AS INTEGER
COMMON SHARED scrn() AS INTEGER
COMMON SHARED colors() AS rgb
COMMON SHARED Font() AS INTEGER
COMMON SHARED mapchange() AS mapchange
COMMON SHARED NPCs() AS NPC
COMMON SHARED items() AS item
COMMON SHARED magic() AS magic
COMMON SHARED shopitems() AS shop
COMMON SHARED trans() AS INTEGER
COMMON SHARED gets() AS getscrn
COMMON SHARED flags() AS INTEGER

COMMON SHARED numspells AS INTEGER
COMMON SHARED rgbval AS STRING * 1
COMMON SHARED scroll AS STRING
COMMON SHARED xscrn AS INTEGER
COMMON SHARED yscrn AS INTEGER
COMMON SHARED xspr AS INTEGER
COMMON SHARED yspr AS INTEGER
COMMON SHARED nomovetile AS INTEGER
COMMON SHARED xmap AS INTEGER
COMMON SHARED ymap AS INTEGER
COMMON SHARED tilename1 AS STRING
COMMON SHARED tilename2 AS STRING
COMMON SHARED palettename AS STRING
COMMON SHARED maptype AS STRING
COMMON SHARED mapname AS STRING
COMMON SHARED mapfile AS STRING
COMMON SHARED edgemapchange AS edgemapchange
COMMON SHARED mapchanges AS INTEGER
COMMON SHARED numNPCs AS INTEGER
COMMON SHARED scriptfile AS STRING
COMMON SHARED fontname AS STRING
COMMON SHARED xfntsize AS INTEGER
COMMON SHARED yfntsize AS INTEGER
COMMON SHARED btextline AS INTEGER
COMMON SHARED responce AS STRING
COMMON SHARED x AS INTEGER
COMMON SHARED y AS INTEGER
COMMON SHARED direction AS INTEGER
COMMON SHARED charstep AS INTEGER
COMMON SHARED yourname AS STRING
COMMON SHARED hp AS INTEGER
COMMON SHARED maxhp AS INTEGER
COMMON SHARED MP AS INTEGER
COMMON SHARED maxmp AS INTEGER
COMMON SHARED strength AS INTEGER
COMMON SHARED defense AS INTEGER
COMMON SHARED speed AS INTEGER
COMMON SHARED level AS INTEGER
COMMON SHARED Gold AS LONG
COMMON SHARED expoints AS LONG
COMMON SHARED weapon AS weapon
COMMON SHARED armor AS armor
COMMON SHARED shield AS shield
COMMON SHARED bstrength AS INTEGER
COMMON SHARED bdefense AS INTEGER
COMMON SHARED bspeed AS INTEGER
COMMON SHARED evade AS INTEGER
COMMON SHARED enname AS STRING
COMMON SHARED enHP AS INTEGER
COMMON SHARED enstrength AS INTEGER
COMMON SHARED endefense AS INTEGER
COMMON SHARED enspeed AS INTEGER
COMMON SHARED enevade AS INTEGER
COMMON SHARED numattacks AS INTEGER
COMMON SHARED getoff AS INTEGER
COMMON SHARED getnum AS INTEGER

DEFINT A-Z

REM $STATIC
SUB showquit
getscrn 80, 99, 166, 121
bevelbox 80, 99, 166, 121, 245, 246, 244, 0
showfont 85, 104, 171, "Are you sure?", 1, 1
showfont 97, 111, 31, "Yes    No", 1, 1
quit = 1
DO
        SELECT CASE quit
                CASE 0: showfont 97, 111, 95, "Yes", 1, 1
                CASE 1: showfont 139, 111, 95, "No", 1, 1
        END SELECT
        DO
                a$ = INKEY$
        LOOP UNTIL a$ <> ""
        showfont 85, 111, 31, "  Yes    No", 1, 1
        IF a$ = CHR$(0) + "K" AND quit = 1 THEN quit = 0
        IF a$ = CHR$(0) + "M" AND quit = 0 THEN quit = 1
        IF a$ = " " THEN
                IF quit = 0 THEN endgame
                EXIT DO
        END IF
LOOP
putscrn 0, 0
END SUB

SUB showsave

getscrn 16, 16, 213, 115
bevelbox 16, 16, 213, 115, 241, 242, 240, 0


getscrn 16, 131, 62, 160
bevelbox 16, 131, 62, 160, 241, 242, 240, 0
showfont 21, 136, 31, "Slot 1", 1, 1
showfont 21, 143, 31, "Slot 2", 1, 1
showfont 21, 150, 31, "Slot 3", 1, 1
save = 1

DO
        showfont 21, 129 + 7 * save, 95, "Slot" + STR$(save), 1, 1
       
        bevelbox 16, 16, 213, 115, 241, 242, 240, 0
        OPEN "rpgdemo\dat\save" + LTRIM$(STR$(save)) + ".sav" FOR INPUT AS 1
        IF LOF(1) = 0 THEN
                showfont 91, 51, 31, "(empty)", 1, 1
        ELSE
                INPUT #1, sname$
                INPUT #1, shp, smaxhp
                INPUT #1, sMP, smaxMP
                INPUT #1, sstrength, sdenense, sspeed
                INPUT #1, sGold, sEXPoint, sLevel
                INPUT #1, sweaponname$, sweaponstr
                INPUT #1, sarmorname$, sarmordef
                INPUT #1, sshieldname$, sshieldevd
                showfont 21, 21, 31, "HP:", 1, 1
                showfont 33, 21, 171, STR$(shp) + "/" + LTRIM$(STR$(smaxhp)), 1, 1
                drawbox 93, 22, 195, 24, 0, 254, 252
                LINE (94, 23)-(94 + 100 * (shp / smaxhp), 23), 253
                showfont 21, 35, 31, "MP:", 1, 1
                showfont 33, 35, 171, STR$(sMP) + "/" + LTRIM$(STR$(smaxMP)), 1, 1
                drawbox 93, 36, 195, 38, 0, 254, 252
                LINE (94, 37)-(94 + 100 * (sMP / smaxMP), 37), 253

                drawbox 21, 50, 208, 52, 245, 246, 244

                showfont 21, 56, 31, "Str:", 1, 1
                showfont 21, 63, 31, "Def:", 1, 1
                showfont 21, 70, 31, "Spd:", 1, 1
                showfont 111, 56, 31, "G:  ", 1, 1
                showfont 111, 63, 31, "EXP:", 1, 1
                showfont 111, 70, 31, "Lvl:", 1, 1
                showfont 39, 56, 171, STR$(sstrength), 1, 1
                showfont 39, 63, 171, STR$(sdefense), 1, 1
                showfont 39, 70, 171, STR$(sspeed), 1, 1
                showfont 129, 56, 171, STR$(sGold), 1, 1
                showfont 129, 63, 171, STR$(sEXPoints), 1, 1
                showfont 129, 70, 171, STR$(sLevel), 1, 1


                drawbox 21, 85, 208, 87, 245, 246, 244

                showfont 21, 91, 31, "Weapon:", 1, 1
                showfont 135, 91, 31, "Str:", 1, 1
                showfont 21, 98, 31, "Armor:", 1, 1
                showfont 135, 98, 31, "Def:", 1, 1
                showfont 21, 105, 31, "Shield:", 1, 1
                showfont 135, 105, 31, "Evd:", 1, 1
                IF sweaponname$ <> " " THEN
                        showfont 63, 91, 171, sweaponname$, 1, 1
                        showfont 159, 91, 171, LTRIM$(STR$(sweaponstr)), 1, 1
                ELSE
                        showfont 63, 91, 171, "-", 1, 1
                        showfont 159, 91, 171, "-", 1, 1
                END IF
                IF sarmorname$ <> " " THEN
                        showfont 63, 98, 171, sarmorname$, 1, 1
                        showfont 159, 98, 171, LTRIM$(STR$(sarmordef)), 1, 1
                ELSE
                        showfont 63, 98, 171, "-", 1, 1
                        showfont 159, 98, 171, "-", 1, 1
                END IF
                IF sshieldname$ <> " " THEN
                        showfont 63, 105, 171, sshieldname$, 1, 1
                        showfont 159, 105, 171, LTRIM$(STR$(sshieldevd)), 1, 1
                ELSE
                        showfont 63, 105, 171, "-", 1, 1
                        showfont 159, 105, 171, "-", 1, 1
                END IF
        END IF
        CLOSE #1
        DO
                a$ = INKEY$
        LOOP WHILE a$ = ""
        IF a$ = CHR$(27) THEN
                putscrn 0, 0
                putscrn 0, 0
                EXIT SUB
        END IF
        showfont 21, 129 + 7 * save, 31, "Slot" + STR$(save), 1, 1
        IF a$ = CHR$(0) + "H" AND save > 1 THEN save = save - 1
        IF a$ = CHR$(0) + "P" AND save < 3 THEN save = save + 1
        IF a$ = " " THEN
                getscrn 70, 131, 303, 153
                bevelbox 70, 131, 290, 153, 245, 246, 244, 0
                showfont 75, 136, 171, "Are you sure you want to save here?", 1, 1
                showfont 135, 143, 31, "Yes       No", 1, 1
                save2 = 1
                DO
                        SELECT CASE save2
                                CASE 1: showfont 135, 143, 95, "Yes", 1, 1
                                CASE 2: showfont 195, 143, 95, "No", 1, 1
                        END SELECT
                        DO
                                a$ = INKEY$
                        LOOP WHILE a$ = ""
                        showfont 135, 143, 31, "Yes       No", 1, 1
                        IF a$ = CHR$(0) + "K" AND save2 = 2 THEN save2 = 1
                        IF a$ = CHR$(0) + "M" AND save2 = 1 THEN save2 = 2
                        IF a$ = " " THEN EXIT DO
                LOOP
                IF save2 = 1 THEN
                        OPEN "rpgdemo\dat\save" + LTRIM$(STR$(save)) + ".sav" FOR OUTPUT AS 1
                        WRITE #1, yourname
                        WRITE #1, hp, maxhp
                        WRITE #1, MP, maxmp
                        WRITE #1, strength, defense, speed
                        WRITE #1, Gold, expoints, level
                        IF ASC(weapon.weaponname) > 0 THEN
                                WRITE #1, weapon.weaponname, weapon.strength
                        ELSE
                                WRITE #1, " ", 0
                        END IF
                        IF ASC(armor.armorname) > 0 THEN
                                WRITE #1, armor.armorname, armor.defense
                        ELSE
                                WRITE #1, " ", 0
                        END IF
                        IF ASC(shield.shieldname) > 0 THEN
                                WRITE #1, shield.shieldname, shield.evade
                        ELSE
                                WRITE #1, " ", 0
                        END IF
                        WRITE #1, mapfile, x, y
                        FOR item = 0 TO 39
                                IF ASC(items(item).itemname) > 0 THEN
                                        WRITE #1, items(item).itemname, items(item).itemtype, items(item).strength, items(item).cost
                                ELSE
                                        WRITE #1, " ", " ", 0, 0
                                END IF
                        NEXT
                        FOR flag = 0 TO 9
                                WRITE #1, flags(flag)
                        NEXT
                        CLOSE #1
                        putscrn 0, 0
                        putscrn 0, 0
                        putscrn 0, 0
                        EXIT SUB
                END IF
                putscrn 0, 0
        END IF
LOOP

'END

'inkey
'putscrn 0, 0

END SUB

SUB showscreen (fade)

IF fade > 0 THEN fadeout 0, 239


IF Undersprite(0, 0, 0) > 0 THEN PUT (xspr, yspr), Undersprite(0, 0, 0), PSET
FOR x2 = x - xscrn TO x + xscrn
        x3 = 16 * (x2 - x + xscrn) + 8
        x4 = x2
        IF maptype = "world" THEN
                IF x4 < 0 THEN x4 = x4 + xmap
                IF x4 >= xmap THEN x4 = x4 - xmap
        END IF
        IF maptype = "town" THEN
                IF x4 < 0 THEN x4 = 0
                IF x4 >= xmap THEN x4 = xmap - 1
        END IF
        FOR y2 = y - yscrn TO y + yscrn
                y3 = 16 * (y2 - y + yscrn) + 8
                y4 = y2
                IF maptype = "world" THEN
                        IF y4 < 0 THEN y4 = y4 + ymap
                        IF y4 >= ymap THEN y4 = y4 - ymap
                END IF
                IF maptype = "town" THEN
                        IF y4 < 0 THEN y4 = 0
                        IF y4 >= ymap THEN y4 = ymap - 1
                END IF
                IF x4 < 0 OR x4 >= xmap OR y4 < 0 OR y4 >= ymap THEN
                        LINE (x3, y3)-(x3 + 15, y3 + 15), 0, BF
                ELSE
                        tile = Map(y4, x4, 0)
                        PUT (x3, y3), Tiles(0, tile, 0), PSET
                        IF x2 = x AND y2 = y THEN
                                GET (xspr, yspr)-(xspr + 15, yspr + 15), Undersprite(0, 0, 0)
                                PUT (xspr, yspr), Sprites(0, 4 * direction + charstep, 1), AND
                                PUT (xspr, yspr), Sprites(0, 4 * direction + charstep, 0), OR
                        END IF
                        IF maptype <> "world" THEN
                                IF Map(y4, x4, 1) > 0 THEN
                                        tile = Map(y4, x4, 1) - 1
                                        PUT (x3, y3), Tiles2(0, tile, 1), AND
                                        PUT (x3, y3), Tiles2(0, tile, 0), OR
                                END IF
                                IF Map(y4, x4, 2) > 0 THEN
                                        NPC = Map(y4, x4, 2)
                                        NPCshow NPC
                                END IF
                        END IF
                END IF
        NEXT
NEXT

IF fade > 0 THEN fadein 0, 239

END SUB

SUB showstats

getscrn 16, 16, 213, 114
bevelbox 16, 16, 213, 114, 241, 242, 240, 0
showfont 21, 21, 31, "HP:", 1, 1
showfont 33, 21, 171, STR$(hp) + "/" + LTRIM$(STR$(maxhp)), 1, 1
drawbox 93, 22, 195, 24, 0, 254, 252
LINE (94, 23)-(94 + 100 * (hp / maxhp), 23), 253
showfont 21, 35, 31, "MP:", 1, 1
showfont 33, 35, 171, STR$(MP) + "/" + LTRIM$(STR$(maxmp)), 1, 1
drawbox 93, 36, 195, 38, 0, 254, 252
LINE (94, 37)-(94 + 100 * (MP / maxmp), 37), 253


drawbox 21, 50, 208, 52, 245, 246, 244

showfont 21, 56, 31, "Str:", 1, 1
showfont 21, 63, 31, "Def:", 1, 1
showfont 21, 70, 31, "Spd:", 1, 1
showfont 111, 56, 31, "G:  ", 1, 1
showfont 111, 63, 31, "EXP:", 1, 1
showfont 111, 70, 31, "Lvl:", 1, 1
showfont 39, 56, 171, STR$(strength), 1, 1
showfont 39, 63, 171, STR$(defense), 1, 1
showfont 39, 70, 171, STR$(speed), 1, 1
showfont 129, 56, 171, STR$(Gold), 1, 1
showfont 129, 63, 171, STR$(expoints), 1, 1
showfont 129, 70, 171, STR$(level), 1, 1


drawbox 21, 85, 208, 87, 245, 246, 244

showfont 21, 91, 31, "Weapon:", 1, 1
showfont 135, 91, 31, "Str:", 1, 1
showfont 21, 98, 31, "Armor:", 1, 1
showfont 135, 98, 31, "Def:", 1, 1
showfont 21, 105, 31, "Shield:", 1, 1
showfont 135, 105, 31, "Evd:", 1, 1
IF ASC(weapon.weaponname) > 0 THEN
        showfont 63, 91, 171, weapon.weaponname, 1, 1
        showfont 159, 91, 171, LTRIM$(STR$(weapon.strength)), 1, 1
ELSE
        showfont 63, 91, 171, "-", 1, 1
        showfont 159, 91, 171, "-", 1, 1
END IF
IF ASC(armor.armorname) > 0 THEN
        showfont 63, 98, 171, armor.armorname, 1, 1
        showfont 159, 98, 171, LTRIM$(STR$(armor.defense)), 1, 1
ELSE
        showfont 63, 98, 171, "-", 1, 1
        showfont 159, 98, 171, "-", 1, 1
END IF
IF ASC(shield.shieldname) > 0 THEN
        showfont 63, 105, 171, shield.shieldname, 1, 1
        showfont 159, 105, 171, LTRIM$(STR$(shield.evade)), 1, 1
ELSE
        showfont 63, 105, 171, "-", 1, 1
        showfont 159, 105, 171, "-", 1, 1
END IF
inkey
putscrn 0, 0


END SUB

SUB skipscript

DO
        INPUT #2, script$
        script$ = LCASE$(script$)
        IF script$ = "end" THEN EXIT DO
LOOP

END SUB

SUB status

getscrn 222, 16, 303, 94
bevelbox 222, 16, 303, 94, 241, 242, 240, 0
showfont 233, 21, 171, yourname, 1, 1


showfont 233, 35, 31, "Status", 1, 1
showfont 233, 42, 31, "Magic", 1, 1
showfont 233, 49, 31, "Item", 1, 1
showfont 233, 56, 31, "Equip", 1, 1
showfont 233, 63, 31, "Save", 1, 1
showfont 233, 70, 31, "Load", 1, 1
showfont 233, 77, 31, "Exit", 1, 1
showfont 233, 84, 31, "Quit", 1, 1

action = 0
DO
        SELECT CASE action
                CASE 0: showfont 233, 35, 95, "Status", 1, 1
                CASE 1: showfont 233, 42, 95, "Magic", 1, 1
                CASE 2: showfont 233, 49, 95, "Item", 1, 1
                CASE 3: showfont 233, 56, 95, "Equip", 1, 1
                CASE 4: showfont 233, 63, 95, "Save", 1, 1
                CASE 5: showfont 233, 70, 95, "Load", 1, 1
                CASE 6: showfont 233, 77, 95, "Exit", 1, 1
                CASE 7: showfont 233, 84, 95, "Quit", 1, 1
        END SELECT
        DO
                a$ = INKEY$
        LOOP UNTIL a$ <> ""
        SELECT CASE action
                CASE 0: showfont 233, 35, 31, "Status", 1, 1
                CASE 1: showfont 233, 42, 31, "Magic", 1, 1
                CASE 2: showfont 233, 49, 31, "Item", 1, 1
                CASE 3: showfont 233, 56, 31, "Equip", 1, 1
                CASE 4: showfont 233, 63, 31, "Save", 1, 1
                CASE 5: showfont 233, 70, 31, "Load", 1, 1
                CASE 6: showfont 233, 77, 31, "Exit", 1, 1
                CASE 7: showfont 233, 84, 31, "Quit", 1, 1
        END SELECT
        'IF a$ = CHR$(27) THEN
        '        PUT (222, 16), scrn, PSET
        '        EXIT SUB
        'END IF
        IF a$ = CHR$(0) + "H" AND action > 0 THEN action = action - 1
        IF a$ = CHR$(0) + "P" AND action < 7 THEN action = action + 1
        IF a$ = " " THEN
                SELECT CASE action
                        CASE 0: showstats
                        CASE 1: showmagic 0
                        CASE 2: showitems 0
                        CASE 3: showequip
                        CASE 4:
                                showsave
                        CASE 5:
                                showload loaded
                                IF loaded > 0 THEN EXIT SUB
                        CASE 6:
                                putscrn 0, 0
                                EXIT SUB
                        CASE 7: showquit
                END SELECT
        END IF
LOOP

inkey

END SUB

SUB textbox (speaker$, text$)

getscrn 8, 154, 311, 183
bevelbox 8, 154, 311, 183, 241, 242, 240, 0
getscrn 8, 138, 18 + 6 * LEN(speaker$), 153
bevelbox 8, 138, 18 + 6 * LEN(speaker$), 153, 241, 242, 240, 0

showfont 13, 143, 171, speaker$, 1, 1

textline$ = ""
textline = 1
letter = 0

DO
        DO
                word$ = ""
                DO
                        letter = letter + 1
                        word$ = word$ + MID$(text$, letter, 1)
                LOOP UNTIL MID$(text$, letter, 1) = " " OR letter = LEN(text$)
                word$ = LTRIM$(RTRIM$(word$))
                IF LEN(textline$) + LEN(word$) < 50 THEN
                        textline$ = textline$ + word$ + " "
                ELSE
                        EXIT DO
                END IF
                IF letter = LEN(text$) THEN EXIT DO
        LOOP
        showfont 13, 152 + 7 * textline, 31, textline$, 1, 1
        IF letter >= LEN(text$) THEN
                IF LEN(textline$) + LEN(word$) < 50 THEN
                        EXIT DO
                END IF
        END IF
        textline = textline + 1
        IF textline = 4 THEN
                inkey
                LINE (11, 157)-(308, 180), 0, BF
                textline = 1
        END IF
        IF letter >= LEN(text$) THEN
                showfont 13, 152 + 7 * textline, 31, word$, 1, 1
                EXIT DO
        END IF
        textline$ = word$ + " "
LOOP

inkey

putscrn 0, 0
putscrn 0, 0

clrkbuffer

END SUB

SUB transbox (x1, y1, x2, y2, col, shade1, shade2)

bevelbox x1, y1, x2, y2, col, shade1, shade2, -1
dotrans x1 + 3, y1 + 3, x2 - 3, y2 - 3

END SUB

SUB useitem (item, inbattle)

IF ASC(items(item).itemname) = 0 THEN EXIT SUB
IF LCASE$(RTRIM$(items(item).itemtype)) <> "item" THEN EXIT SUB

IF inbattle = 0 THEN
        getscrn 16, 146, 303, 175
        bevelbox 16, 146, 303, 175, 241, 242, 240, 0
END IF

SELECT CASE LCASE$(RTRIM$(items(item).itemname))
        CASE "herb"
                hp = hp + 10
                IF hp > maxhp THEN hp = maxhp
                IF inbattle = 0 THEN
                        showfont 21, 151, 31, "10 HP have been restored", 1, 1
                ELSE
                        battletext "10 HP have been restored"
                END IF
        CASE "x-herb"
                hp = hp + 25
                IF hp > maxhp THEN hp = maxhp
                IF inbattle = 0 THEN
                        showfont 21, 151, 31, "25 HP have been restored", 1, 1
                ELSE
                        battletext "25 HP have been restored"
                END IF
        CASE "magi"
                MP = MP + 10
                IF MP > maxmp THEN MP = maxmp
                IF inbattle = 0 THEN
                        showfont 21, 151, 31, "10 MP have been restored", 1, 1
                ELSE
                        battletext "10 MP have been restored"
                END IF
        CASE "x-magi"
                MP = MP + 25
                IF MP > maxmp THEN MP = maxmp
                IF inbattle = 0 THEN
                        showfont 21, 151, 31, "25 MP have been restored", 1, 1
                ELSE
                        battletext "25 MP have been restored"
                END IF
END SELECT

items(item).itemname = CHR$(0)
items(item).itemtype = CHR$(0)
items(item).strength = 0
items(item).cost = 0

inkey

IF inbattle = 0 THEN putscrn 0, 0

END SUB

SUB usemagic (spell, inbattle)

IF inbattle = 0 THEN
        getscrn 16, 146, 303, 175
        bevelbox 16, 146, 303, 175, 241, 242, 240, 0
END IF

IF magic(spell).useoutofbattle = 0 AND inbattle = 0 THEN
        showfont 21, 151, 31, "You can only use this spell in battles", 1, 1
        inkey
        putscrn 0, 0
        EXIT SUB
END IF
IF magic(spell).cost > MP THEN
        IF inbattle = 0 THEN
                showfont 21, 151, 31, "You don't have enough MP", 1, 1
        ELSE
                battletext "You don't have enough MP"
        END IF
        inkey
        IF inbattle = 0 THEN putscrn 0, 0
        EXIT SUB
END IF


MP = MP - magic(spell).cost

IF inbattle = 1 THEN
        playani "magic.put", 54, 66, 32, 32, .1
        LINE (208, 35)-(250, 40), 0, BF
        showfont 208, 35, 171, STR$(MP) + "/" + LTRIM$(STR$(maxmp)), 1, 1
        LINE (197, 44)-(297, 44), 0
        LINE (197, 44)-(197 + 100 * (MP / maxmp), 44), 253
END IF

IF RND * 100 > magic(spell).hitpercent THEN
        showfont 21, 151, 31, "The spell did not work!", 1, 1
        inkey
        IF inbattle = 0 THEN putscrn 0, 0
        EXIT SUB
END IF

SELECT CASE LCASE$(RTRIM$(magic(spell).spellname))
        CASE "heal"
                cured = 25
                IF hp + cured > maxhp THEN cured = maxhp - hp
                hp = hp + cured
                IF inbattle = 1 THEN
                        LINE (208, 21)-(250, 26), 0, BF
                        showfont 208, 21, 171, STR$(hp) + "/" + LTRIM$(STR$(maxhp)), 1, 1
                        LINE (197, 30)-(297, 30), 0
                        LINE (197, 30)-(197 + 100 * (hp / maxhp), 30), 253
                END IF
                IF inbattle = 0 THEN
                        showfont 21, 151, 31, "You gained" + STR$(cured) + " HP", 1, 1
                ELSE
                        battletext "You gained" + STR$(cured) + " HP"
                END IF
        CASE "heal2"
                cured = 75
                IF hp + cured > maxhp THEN cured = maxhp - hp
                hp = hp + cured
                IF inbattle = 1 THEN
                        LINE (208, 21)-(250, 26), 0, BF
                        showfont 208, 21, 171, STR$(hp) + "/" + LTRIM$(STR$(maxhp)), 1, 1
                        LINE (197, 30)-(297, 30), 0
                        LINE (197, 30)-(197 + 100 * (hp / maxhp), 30), 253
                END IF
                IF inbattle = 0 THEN
                        showfont 21, 151, 31, "You gained" + STR$(cured) + " HP", 1, 1
                ELSE
                        battletext "You gained" + STR$(cured) + " HP"
                END IF
        CASE "hurt"
                damage = 25
                IF enHP - damage < 0 THEN damge = enHP
                enHP = enHP - damage
                playani2 Battlemagic(), 0, 1, 123, 30, 0, 2, 15, .0001
                battletext "You dealt" + STR$(damage) + " damage"
        CASE "hurt2"
                damage = 50
                IF enHP - damage < 0 THEN damge = enHP
                enHP = enHP - damage
                playani2 Battlemagic(), 0, 1, 123, 30, 0, 2, 15, .0001
                battletext "You dealt" + STR$(damage) + " damage"
        CASE "slow"
                enSpd = enSpd / 2
                battletext "The " + enname + "'s speed was cut in half"
        CASE "haste"
                bSpd = bSpd * 2
                battletext "Your speed has doubled"
        CASE "weak"
                enStr = enStr / 2
                enDef = enDef / 2
                battletext "The " + enname + "'s Str and Def were cut in half"
        CASE "strong"
                bStr = bStr * 2
                bDef = bDef * 2
                battletext "Your Str and Def have doubled"
        CASE "death"
                enHP = 0
                battletext "The " + enname + " withered away"
END SELECT

inkey
IF inbattle = 1 THEN
        PUT (54, 66), battlearray, PSET
        PUT (54, 66), BattleChar(0, 0, 1), AND
        PUT (54, 66), BattleChar(0, 0, 0), OR
END IF

IF inbattle = 0 THEN putscrn 0, 0

END SUB

SUB wingame

END

END SUB

