'$DYNAMIC

DECLARE SUB battle (ennum%)
DECLARE SUB battletext (text$)
DECLARE SUB bevelbox (x1%, y1%, x2%, y2%, col%, shade1%, shade2%, fill%)
DECLARE SUB changemap ()
DECLARE SUB clearscreen (mode%)
DECLARE SUB clrkbuffer ()
DECLARE SUB doscroll (scrolldir$)
DECLARE SUB doenattack (attackname$, damage%)
DECLARE SUB doitem (item%, text$)
DECLARE SUB doscript (scriptname$, scriptnum%)
DECLARE SUB dotrans (x1%, y1%, x2%, y2%)
DECLARE SUB drawbox (x1%, y1%, x2%, y2%, col%, shade1%, shade2%)
DECLARE SUB enattack (attackname$)
DECLARE SUB endgame ()
DECLARE SUB extractarray (xextract%, yextract%, array1%(), array2%())
DECLARE SUB fadeout (col1%, col2%)
DECLARE SUB fadein (col1%, col2%)
DECLARE SUB getscrn (x1%, y1%, x2%, y2%)
DECLARE SUB growbevelbox (x1%, y1%, x2%, y2%, col%, shade1%, shade2%, steps%)
DECLARE SUB growbox (x1%, y1%, x2%, y2%, col%, shade1%, shade2%, steps%)
DECLARE SUB initvars ()
DECLARE SUB inkey ()
DECLARE SUB inn (price%)
DECLARE SUB inputstring (xfnt%, yfnt%, colour%, text$, var$, maxlength%, xshade%, yshade%, bgcolor%)
DECLARE SUB inputvar (xfnt%, yfnt%, colour%, text$, var%, maxlength%, xshade%, yshade%, bgcolor%)
DECLARE SUB itemnamesort ()
DECLARE SUB itemtypesort ()
DECLARE SUB loaden (file$)
DECLARE SUB loadfont (filename$)
DECLARE SUB loadmagic (file$)
DECLARE SUB loadmap (filename$)
DECLARE SUB loadpalette (filename$)
DECLARE SUB loadshop (shopname$, numitems%)
DECLARE SUB loadsprite (file$, Spritearray%())
DECLARE SUB loadsprite2 (file$, Spritearray%())
DECLARE SUB loadtiles1 (tilename$)
DECLARE SUB loadtiles2 (tilename$)
DECLARE SUB movescrn (x1%, y1%, x2%, y2%, xoff%, yoff%)
DECLARE SUB NPCinteract (interx%, intery%)
DECLARE SUB NPCmove (NPC%, direction%)
DECLARE SUB NPCshow (NPC%)
DECLARE SUB pal (colour%, r%, g%, b%)
DECLARE SUB pastearray (xpaste%, ypaste%, array1%(), array2%(), tilenum%)
DECLARE SUB pause (seconds#)
DECLARE SUB playani (file$, anix%, aniy%, xsize%, ysize%, delay#)
DECLARE SUB playani2 (aniarray%(), tilenum1%, tilenum2%, anix%, aniy%, xchng%, ychng%, frames%, delay#)
DECLARE SUB putscrn (xoff%, yoff%)
DECLARE SUB question (speaker$, text$)
DECLARE SUB readscript ()
DECLARE SUB settrans ()
DECLARE SUB shop (shopname$)
DECLARE SUB showequip ()
DECLARE SUB showfont (xfnt%, yfnt%, colour%, text$, shadex%, shadey%)
DECLARE SUB showitems (inbattle%)
DECLARE SUB showmagic (inbattle%)
DECLARE SUB showload (loaded%)
DECLARE SUB showquit ()
DECLARE SUB showsave ()
DECLARE SUB showscreen (fade%)
DECLARE SUB showstats ()
DECLARE SUB skipscript ()
DECLARE SUB status ()
DECLARE SUB textbox (speaker$, text$)
DECLARE SUB transbox (x1%, y1%, x2%, y2%, col%, shade1%, shade2%)
DECLARE SUB useitem (item%, inbattle%)
DECLARE SUB usemagic (spell%, inbattle%)
DECLARE SUB wingame ()

TYPE rgb
        r AS INTEGER
        g AS INTEGER
        b AS INTEGER
END TYPE

TYPE mapchange
        x AS INTEGER
        y AS INTEGER
        mapname AS STRING * 12
        newx AS INTEGER
        newy AS INTEGER
END TYPE

TYPE edgemapchange
        mapname AS STRING * 12
        x AS INTEGER
        y AS INTEGER
END TYPE

TYPE NPC
        x AS INTEGER
        y AS INTEGER
        NPCname AS STRING * 12
        spriteset AS INTEGER
        direction AS INTEGER
        scriptnum AS INTEGER
END TYPE

TYPE item
        itemname AS STRING * 12
        itemtype AS STRING * 12
        strength AS INTEGER
        cost AS INTEGER
END TYPE

TYPE magic
        spellname AS STRING * 12
        level AS INTEGER
        cost AS INTEGER
        hitpercent AS INTEGER
        useoutofbattle AS INTEGER
        learned AS INTEGER
END TYPE

TYPE weapon
        weaponname AS STRING * 12
        strength AS INTEGER
END TYPE

TYPE armor
        armorname AS STRING * 12
        defense AS INTEGER
END TYPE

TYPE shield
        shieldname AS STRING * 12
        evade AS INTEGER
END TYPE

TYPE shop
        itemname AS STRING * 12
        itemtype AS STRING * 12
        strength AS INTEGER
        cost AS INTEGER
END TYPE

TYPE enemy
        hp AS INTEGER
        enname AS STRING * 8
        strength AS INTEGER
        defense AS INTEGER
        evade AS INTEGER
        speed AS INTEGER
        newgold AS INTEGER
        newexp AS INTEGER
        numattacks AS INTEGER
END TYPE
   
TYPE getscrn
        getoff AS INTEGER
        x1 AS INTEGER
        y1 AS INTEGER
        x2 AS INTEGER
        y2 AS INTEGER
END TYPE


COMMON SHARED Tiles() AS INTEGER
COMMON SHARED Tiles2() AS INTEGER
COMMON SHARED Sprites() AS INTEGER
COMMON SHARED NPCSpr() AS INTEGER
COMMON SHARED Undersprite() AS INTEGER
COMMON SHARED BattleChar() AS INTEGER
COMMON SHARED BattleEn() AS INTEGER
COMMON SHARED enemy() AS enemy
COMMON SHARED EnAttacks() AS STRING
COMMON SHARED Battlemagic() AS INTEGER
COMMON SHARED tempsprite() AS INTEGER
COMMON SHARED aniarray() AS INTEGER
COMMON SHARED Aniarray2() AS INTEGER
COMMON SHARED temparray() AS INTEGER
COMMON SHARED battlearray() AS INTEGER
COMMON SHARED battlearray2() AS INTEGER
COMMON SHARED anitemp() AS INTEGER
COMMON SHARED Map() AS INTEGER
COMMON SHARED scrn() AS INTEGER
COMMON SHARED colors() AS rgb
COMMON SHARED Font() AS INTEGER
COMMON SHARED mapchange() AS mapchange
COMMON SHARED NPCs() AS NPC
COMMON SHARED items() AS item
COMMON SHARED magic() AS magic
COMMON SHARED shopitems() AS shop
COMMON SHARED trans() AS INTEGER
COMMON SHARED gets() AS getscrn
COMMON SHARED flags() AS INTEGER

COMMON SHARED numspells AS INTEGER
COMMON SHARED rgbval AS STRING * 1
COMMON SHARED scroll AS STRING
COMMON SHARED xscrn AS INTEGER
COMMON SHARED yscrn AS INTEGER
COMMON SHARED xspr AS INTEGER
COMMON SHARED yspr AS INTEGER
COMMON SHARED nomovetile AS INTEGER
COMMON SHARED xmap AS INTEGER
COMMON SHARED ymap AS INTEGER
COMMON SHARED tilename1 AS STRING
COMMON SHARED tilename2 AS STRING
COMMON SHARED palettename AS STRING
COMMON SHARED maptype AS STRING
COMMON SHARED mapname AS STRING
COMMON SHARED mapfile AS STRING
COMMON SHARED edgemapchange AS edgemapchange
COMMON SHARED mapchanges AS INTEGER
COMMON SHARED numNPCs AS INTEGER
COMMON SHARED scriptfile AS STRING
COMMON SHARED fontname AS STRING
COMMON SHARED xfntsize AS INTEGER
COMMON SHARED yfntsize AS INTEGER
COMMON SHARED btextline AS INTEGER
COMMON SHARED responce AS STRING
COMMON SHARED x AS INTEGER
COMMON SHARED y AS INTEGER
COMMON SHARED direction AS INTEGER
COMMON SHARED charstep AS INTEGER
COMMON SHARED yourname AS STRING
COMMON SHARED hp AS INTEGER
COMMON SHARED maxhp AS INTEGER
COMMON SHARED MP AS INTEGER
COMMON SHARED maxmp AS INTEGER
COMMON SHARED strength AS INTEGER
COMMON SHARED defense AS INTEGER
COMMON SHARED speed AS INTEGER
COMMON SHARED level AS INTEGER
COMMON SHARED Gold AS LONG
COMMON SHARED expoints AS LONG
COMMON SHARED weapon AS weapon
COMMON SHARED armor AS armor
COMMON SHARED shield AS shield
COMMON SHARED bstrength AS INTEGER
COMMON SHARED bdefense AS INTEGER
COMMON SHARED bspeed AS INTEGER
COMMON SHARED evade AS INTEGER
COMMON SHARED enname AS STRING
COMMON SHARED enHP AS INTEGER
COMMON SHARED enstrength AS INTEGER
COMMON SHARED endefense AS INTEGER
COMMON SHARED enspeed AS INTEGER
COMMON SHARED enevade AS INTEGER
COMMON SHARED numattacks AS INTEGER
COMMON SHARED getoff AS INTEGER
COMMON SHARED getnum AS INTEGER

DEFINT A-Z

REM $STATIC
SUB playani2 (aniarray%(), tilenum1, tilenum2, anix, aniy, xchng, ychng, frames, delay#)

tilenum = tilenum1
GET (anix, aniy)-(anix + 15, aniy + 15), anitemp
PUT (anix, aniy), aniarray%(0, tilenum, 1), AND
PUT (anix, aniy), aniarray%(0, tilenum, 0), OR
pause delay#
PUT (anix, aniy), anitemp, PSET
FOR frame = 1 TO frames
        tilenum = tilenum + 1
        IF tilenum > tilenum2 THEN tilenum = tilenum1
        anix = anix + xchng
        aniy = aniy + ychng
        GET (anix, aniy)-(anix + 15, aniy + 15), anitemp
        PUT (anix, aniy), aniarray%(0, tilenum, 1), AND
        PUT (anix, aniy), aniarray%(0, tilenum, 0), OR
        pause delay#
        PUT (anix, aniy), anitemp, PSET
NEXT

END SUB

SUB putscrn (xoff, yoff)

getnum = getnum - 1

getoff = gets(getnum).getoff
x1 = gets(getnum).x1 + xoff
y1 = gets(getnum).y1 + yoff
PUT (x1, y1), scrn(getoff), PSET


END SUB

SUB question (speaker$, text$)

getscrn 8, 154, 311, 183
bevelbox 8, 154, 311, 183, 241, 242, 240, 0
getscrn 8, 138, 18 + 6 * LEN(speaker$), 153
bevelbox 8, 138, 18 + 6 * LEN(speaker$), 153, 241, 242, 240, 0

showfont 13, 143, 171, speaker$, 1, 1

textline$ = ""
textline = 1
letter = 0

DO
        DO
                word$ = ""
                DO
                        letter = letter + 1
                        word$ = word$ + MID$(text$, letter, 1)
                LOOP UNTIL MID$(text$, letter, 1) = " " OR letter = LEN(text$)
                word$ = LTRIM$(RTRIM$(word$))
                IF LEN(textline$) + LEN(word$) < 50 THEN
                        textline$ = textline$ + word$ + " "
                ELSE
                        EXIT DO
                END IF
                IF letter = LEN(text$) THEN EXIT DO
        LOOP
        showfont 13, 152 + 7 * textline, 31, textline$, 1, 1
        IF letter >= LEN(text$) THEN
                IF LEN(textline$) + LEN(word$) < 50 THEN
                        EXIT DO
                END IF
        END IF
        textline = textline + 1
        IF textline = 4 THEN
                inkey
                LINE (11, 157)-(308, 180), 0, BF
                textline = 1
        END IF
        IF letter >= LEN(text$) THEN
                showfont 13, 152 + 7 * textline, 31, word$, 1, 1
                EXIT DO
        END IF
        textline$ = word$ + " "
LOOP

showfont 97, 173, 31, "Yes    No", 1, 1
responce = "yes"
DO
        SELECT CASE responce
                CASE "yes": showfont 97, 173, 95, "Yes", 1, 1
                CASE "no": showfont 139, 173, 95, "No", 1, 1
        END SELECT
        DO
                a$ = INKEY$
        LOOP UNTIL a$ <> ""
        showfont 85, 173, 31, "  Yes    No", 1, 1
        IF a$ = CHR$(0) + "K" AND responce = "no" THEN responce = "yes"
        IF a$ = CHR$(0) + "M" AND responce = "yes" THEN responce = "no"
        IF a$ = " " THEN EXIT DO
LOOP

PUT (8, 154), scrn, PSET
PUT (8, 138), scrn(4562), PSET
putscrn 0, 0
putscrn 0, 0

clrkbuffer

END SUB

SUB readscript

DO
        INPUT #2, script$
        script$ = LCASE$(script$)
        IF script$ = "end" THEN EXIT DO
        SELECT CASE script$
                CASE "textbox"
                        INPUT #2, NPCname$, text$
                        textbox NPCname$, text$
                CASE "question"
                        INPUT #2, NPCname$, text$
                        question NPCname$, text$
                CASE "shop"
                        INPUT #2, shopname$
                        shop shopname$
                CASE "setflag"
                        INPUT #2, flagnum, flagvalue
                        flags(flagnum) = flagvalue
                CASE "ifflag"
                        INPUT #2, flagnum, flagvalue
                        IF flags(flagnum) = flagvalue THEN
                                readscript
                        ELSE
                                skipscript
                        END IF
                CASE "ifresponce"
                        INPUT #2, testresponce$
                        IF LCASE$(responce) = LCASE$(testresponce$) THEN
                                readscript
                        ELSE
                                skipscript
                        END IF
                CASE "ifgold"
                        INPUT #2, mingold
                        IF Gold >= mingold THEN
                                readscript
                        ELSE
                                skipscript
                        END IF
                CASE "paygold"
                        INPUT #2, numgold
                        Gold = Gold - numgold
                CASE "battle"
                        INPUT #2, enemy
                        battle enemy
                CASE "scroll"
                        INPUT #2, numsteps, delay#
                        FOR steps = 1 TO numsteps
                                INPUT #2, dir$
                                doscroll dir$
                                pause delay#
                        NEXT
                CASE "npcmove"
                        INPUT #2, NPC, delay#, numsteps
                        FOR steps = 1 TO numsteps
                                INPUT #2, dir
                                NPCmove NPC, dir
                                pause delay#
                        NEXT
                CASE "loadmap"
                        INPUT #2, file$
                        loadmap file$
                CASE "setxydir"
                        INPUT #2, x, y, direction
                CASE "showscreen"
                        showscreen 0
                CASE "setmapval"
                        INPUT #2, mapx, mapy, layer, newval
                        Map(mapy, mapx, layer) = newval
                CASE "npcsetxydir"
                        INPUT #2, NPC, NPCx, NPCy, NPCdir
                        NPCs(NPC).x = NPCx
                        NPCs(NPC).y = NPCy
                        NPCs(NPC).direction = NPCdir
                        NPCshow NPC
        END SELECT
LOOP

END SUB

SUB settrans

FOR col = 0 TO 255
        r = colors(col).r
        g = colors(col).g
        b = colors(col).b
        rgb = r + g + b
        IF rgb < 64 THEN
                trans = 64 + INT(rgb / 8)
        ELSE
                trans = 72 + INT((rgb - 64) / 8)
                IF trans > 79 THEN trans = 79
        END IF
        trans(col) = trans
NEXT

END SUB

SUB shop (shopname$)

loadshop shopname$, numitems

getscrn 16, 16, 303, 30         'area under Welcome message
getscrn 16, 38, 60, 66          'area under Menu
getscrn 16, 153, 60, 175        'area under Gold box

bevelbox 16, 16, 303, 30, 241, 242, 240, 0
bevelbox 16, 38, 60, 66, 241, 242, 240, 0
bevelbox 16, 153, 60, 175, 241, 242, 240, 0
showfont 28, 21, 31, "What can I do for you?", 1, 1
showfont 28, 43, 31, "Buy", 1, 1
showfont 28, 50, 31, "Sell", 1, 1
showfont 28, 57, 31, "Exit", 1, 1
showfont 21, 158, 95, "Gold:", 1, 1
showfont 21, 165, 31, LTRIM$(STR$(Gold)), 1, 1

action = 0
DO
        SELECT CASE action
                CASE 0: showfont 28, 43, 95, "Buy", 1, 1
                CASE 1: showfont 28, 50, 95, "Sell", 1, 1
                CASE 2: showfont 28, 57, 95, "Exit", 1, 1
        END SELECT
        DO
                a$ = INKEY$
        LOOP WHILE a$ = ""
        IF a$ = CHR$(27) THEN
                putscrn 0, 0
                putscrn 0, 0
                putscrn 0, 0
                EXIT SUB
        END IF
        SELECT CASE action
                CASE 0: showfont 28, 43, 31, "Buy", 1, 1
                CASE 1: showfont 28, 50, 31, "Sell", 1, 1
                CASE 2: showfont 28, 57, 31, "Exit", 1, 1
        END SELECT
        IF a$ = CHR$(0) + "H" AND action > 0 THEN action = action - 1
        IF a$ = CHR$(0) + "P" AND action < 2 THEN action = action + 1
        IF a$ = " " THEN
                IF action = 0 THEN
                        getscrn 68, 38, 303, 130        'area under Item list
                        bevelbox 68, 38, 303, 130, 241, 242, 240, 0
                        showfont 80, 43, 171, "Item", 1, 1
                        showfont 158, 43, 171, "Type", 1, 1
                        showfont 236, 43, 171, "Str", 1, 1
                        showfont 266, 43, 171, "Cost", 1, 1
                        drawbox 74, 51, 297, 53, 245, 246, 244
                        FOR item = 1 TO numitems
                                showfont 80, 50 + 7 * item, 31, shopitems(item).itemname, 1, 1
                                showfont 158, 50 + 7 * item, 31, shopitems(item).itemtype, 1, 1
                                IF shopitems(item).strength <> 0 THEN
                                        showfont 236, 50 + 7 * item, 31, LTRIM$(STR$(shopitems(item).strength)), 1, 1
                                ELSE
                                        showfont 236, 50 + 7 * item, 31, "--", 1, 1
                                END IF
                                showfont 266, 50 + 7 * item, 31, LTRIM$(STR$(shopitems(item).cost)), 1, 1
                        NEXT
                        item = 1
                        DO
                                showfont 80, 50 + 7 * item, 95, shopitems(item).itemname, 1, 1
                                showfont 158, 50 + 7 * item, 95, shopitems(item).itemtype, 1, 1
                                IF shopitems(item).strength <> 0 THEN
                                        showfont 236, 50 + 7 * item, 95, LTRIM$(STR$(shopitems(item).strength)), 1, 1
                                ELSE
                                        showfont 236, 50 + 7 * item, 95, "--", 1, 1
                                END IF
                                showfont 266, 50 + 7 * item, 95, LTRIM$(STR$(shopitems(item).cost)), 1, 1
                                DO
                                        a$ = INKEY$
                                LOOP UNTIL a$ <> ""
                                showfont 80, 50 + 7 * item, 31, shopitems(item).itemname, 1, 1
                                showfont 158, 50 + 7 * item, 31, shopitems(item).itemtype, 1, 1
                                IF shopitems(item).strength <> 0 THEN
                                        showfont 236, 50 + 7 * item, 31, LTRIM$(STR$(shopitems(item).strength)), 1, 1
                                ELSE
                                        showfont 236, 50 + 7 * item, 31, "--", 1, 1
                                END IF
                                showfont 266, 50 + 7 * item, 31, LTRIM$(STR$(shopitems(item).cost)), 1, 1
                                IF a$ = CHR$(0) + "H" AND item > 1 THEN item = item - 1
                                IF a$ = CHR$(0) + "P" AND item < numitems THEN item = item + 1
                                IF a$ = CHR$(27) THEN EXIT DO
                                IF a$ = " " THEN
                                        IF Gold >= shopitems(item).cost THEN
                                                item2 = 0
                                                DO
                                                        IF MID$(items(item2).itemname, 1, 1) = CHR$(0) THEN
                                                                Gold = Gold - shopitems(item).cost
                                                                LINE (21, 165)-(55, 170), 0, BF
                                                                showfont 21, 165, 31, LTRIM$(STR$(Gold)), 1, 1
                                                                items(item2).itemname = shopitems(item).itemname
                                                                items(item2).itemtype = shopitems(item).itemtype
                                                                items(item2).strength = shopitems(item).strength
                                                                items(item2).cost = shopitems(item).cost / 2
                                                                EXIT DO
                                                        END IF
                                                        item2 = item2 + 1
                                                        IF item2 = 40 THEN
                                                                getscrn 68, 138, 303, 152
                                                                bevelbox 68, 138, 303, 152, 241, 242, 240, 0
                                                                showfont 73, 143, 31, "You don't have any room", 1, 1
                                                                inkey
                                                                putscrn 0, 0
                                                                EXIT DO
                                                        END IF
                                                LOOP
                                        ELSE
                                                getscrn 68, 138, 303, 152
                                                bevelbox 68, 138, 303, 152, 241, 242, 240, 0
                                                showfont 73, 143, 31, "You don't have enough gold", 1, 1
                                                inkey
                                                putscrn 0, 0
                                        END IF
                                END IF
                        LOOP
                        putscrn 0, 0
                END IF
                IF action = 1 THEN
                        getscrn 68, 38, 303, 130        'area under Item list
                        bevelbox 68, 38, 303, 130, 241, 242, 240, 0
                        showfont 80, 43, 171, "Item", 1, 1
                        showfont 158, 43, 171, "Type", 1, 1
                        showfont 236, 43, 171, "Str", 1, 1
                        showfont 266, 43, 171, "Cost", 1, 1
                        drawbox 74, 51, 297, 53, 245, 246, 244
                        FOR item = 0 TO 9
                                IF ASC(MID$(items(item).itemname, 1, 1)) <> 0 THEN
                                        showfont 80, 57 + 7 * item, 31, items(item).itemname, 1, 1
                                        showfont 158, 57 + 7 * item, 31, items(item).itemtype, 1, 1
                                        IF items(item).strength <> 0 THEN
                                                showfont 236, 57 + 7 * item, 31, LTRIM$(STR$(items(item).strength)), 1, 1
                                        ELSE
                                                showfont 236, 57 + 7 * item, 31, "--", 1, 1
                                        END IF
                                        showfont 266, 57 + 7 * item, 31, LTRIM$(STR$(items(item).cost)), 1, 1
                                ELSE
                                        showfont 80, 57 + 7 * item, 31, " --", 1, 1
                                END IF
                        NEXT
                        drawbox 295, 57, 299, 125, 253, 254, 252
                        item2 = 0
                        itemlist1 = 0
                        itemlist2 = itemlist1 + 9
                        DO
                                IF ASC(MID$(items(item2).itemname, 1, 1)) <> 0 THEN
                                        showfont 80, 57 + 7 * (item2 - itemlist1), 95, items(item2).itemname, 1, 1
                                        showfont 158, 57 + 7 * (item2 - itemlist1), 95, items(item2).itemtype, 1, 1
                                        IF items(item2).strength <> 0 THEN
                                                showfont 236, 57 + 7 * (item2 - itemlist1), 95, LTRIM$(STR$(items(item2).strength)), 1, 1
                                        ELSE
                                                showfont 236, 57 + 7 * (item2 - itemlist1), 95, "--", 1, 1
                                        END IF
                                        showfont 266, 57 + 7 * (item2 - itemlist1), 95, LTRIM$(STR$(items(item2).cost)), 1, 1
                                ELSE
                                        showfont 80, 57 + 7 * (item2 - itemlist1), 95, " --", 1, 1
                                END IF
                                drawbox 296, 64 * (item2 / 39) + 58, 298, 64 * (item2 / 39) + 60, 253, 254, 252
                                DO
                                        a$ = INKEY$
                                LOOP UNTIL a$ <> ""
                                IF ASC(MID$(items(item2).itemname, 1, 1)) <> 0 THEN
                                        showfont 80, 57 + 7 * (item2 - itemlist1), 31, items(item2).itemname, 1, 1
                                        showfont 158, 57 + 7 * (item2 - itemlist1), 31, items(item2).itemtype, 1, 1
                                        IF items(item2).strength <> 0 THEN
                                                showfont 236, 57 + 7 * (item2 - itemlist1), 31, LTRIM$(STR$(items(item2).strength)), 1, 1
                                        ELSE
                                                showfont 236, 57 + 7 * (item2 - itemlist1), 31, "--", 1, 1
                                        END IF
                                        showfont 266, 57 + 7 * (item2 - itemlist1), 31, LTRIM$(STR$(items(item2).cost)), 1, 1
                                ELSE
                                        showfont 80, 57 + 7 * (item2 - itemlist1), 31, " --", 1, 1
                                END IF
                                LINE (296, 64 * (item2 / 39) + 58)-(298, 64 * (item2 / 39) + 60), 253, BF
                                IF a$ = CHR$(27) THEN EXIT DO
                                IF a$ = CHR$(0) + "H" AND item2 > 0 THEN
                                        item2 = item2 - 1
                                        IF item2 < itemlist1 THEN
                                                movescrn 80, 57, 294, 119, 0, 7
                                                itemlist1 = itemlist1 - 1
                                                itemlist2 = itemlist2 - 1
                                                LINE (80, 57)-(294, 62), 0, BF
                                        END IF
                                END IF
                                IF a$ = CHR$(0) + "P" AND item2 < 39 THEN
                                        item2 = item2 + 1
                                        IF item2 > itemlist2 THEN
                                                movescrn 80, 64, 294, 126, 0, -7
                                                itemlist1 = itemlist1 + 1
                                                itemlist2 = itemlist2 + 1
                                                LINE (80, 120)-(294, 125), 0, BF
                                        END IF
                                END IF
                                IF a$ = " " THEN
                                        Gold = Gold + items(item2).cost
                                        LINE (21, 165)-(55, 170), 0, BF
                                        showfont 21, 165, 31, LTRIM$(STR$(Gold)), 1, 1
                                        items(item2).itemname = CHR$(0)
                                        items(item2).itemtype = CHR$(0)
                                        items(item2).strength = 0
                                        items(item2).cost = 0
                                        LINE (80, 57 + 7 * (item2 - itemlist1))-(294, 62 + 7 * (item2 - itemlist1)), 0, BF
                                END IF
                        LOOP
                        putscrn 0, 0
                END IF
                IF action = 2 THEN
                        putscrn 0, 0
                        putscrn 0, 0
                        putscrn 0, 0
                        EXIT DO
                END IF
        END IF
LOOP



END SUB

SUB showequip

getscrn 16, 16, 213, 121
bevelbox 16, 16, 213, 121, 241, 242, 240, 0

showfont 27, 21, 31, "Weapon:               Str:", 1, 1
showfont 27, 28, 31, "Armor:                Def:", 1, 1
showfont 27, 35, 31, "Shield:               Evd:", 1, 1

IF ASC(weapon.weaponname) > 0 THEN
        showfont 69, 21, 171, weapon.weaponname, 1, 1
        showfont 183, 21, 171, LTRIM$(STR$(weapon.strength)), 1, 1
ELSE
        showfont 69, 21, 171, "-", 1, 1
        showfont 183, 21, 171, "-", 1, 1
END IF
IF ASC(armor.armorname) > 0 THEN
        showfont 69, 28, 171, armor.armorname, 1, 1
        showfont 183, 28, 171, LTRIM$(STR$(armor.defense)), 1, 1
ELSE
        showfont 69, 28, 171, "-", 1, 1
        showfont 183, 28, 171, "-", 1, 1
END IF
IF ASC(shield.shieldname) > 0 THEN
        showfont 69, 35, 171, shield.shieldname, 1, 1
        showfont 183, 35, 171, LTRIM$(STR$(shield.evade)), 1, 1
ELSE
        showfont 69, 35, 171, "-", 1, 1
        showfont 183, 35, 171, "-", 1, 1
END IF

drawbox 21, 43, 208, 45, 245, 246, 244
FOR equip = 0 TO 9
        IF ASC(MID$(items(equip).itemname, 1, 1)) <> 0 THEN
                showfont 27, 49 + 7 * equip, 31, items(equip).itemname, 1, 1
                showfont 117, 49 + 7 * equip, 31, items(equip).itemtype, 1, 1
        ELSE
                showfont 27, 49 + 7 * equip, 31, " --", 1, 1
        END IF
NEXT
drawbox 205, 49, 209, 117, 253, 254, 252
equipmenu = 0
equip = 0
equip2 = 0
equiporder = 0
equiplist1 = 0
equiplist2 = equiplist1 + 9

DO
        SELECT CASE equip
                CASE 0: showfont 27, 21, 95, "Weapon:               Str:", 1, 1
                CASE 1: showfont 27, 28, 95, "Armor:                Def:", 1, 1
                CASE 2: showfont 27, 35, 95, "Shield:               Evd:", 1, 1
        END SELECT
        DO
                a$ = INKEY$
        LOOP UNTIL a$ <> ""
        SELECT CASE equip
                CASE 0: showfont 27, 21, 31, "Weapon:               Str:", 1, 1
                CASE 1: showfont 27, 28, 31, "Armor:                Def:", 1, 1
                CASE 2: showfont 27, 35, 31, "Shield:               Evd:", 1, 1
        END SELECT
        IF a$ = CHR$(27) THEN EXIT DO
        IF a$ = " " THEN
                DO
                        IF ASC(MID$(items(equip2).itemname, 1, 1)) <> 0 THEN
                                showfont 27, 49 + 7 * (equip2 - equiplist1), 95, items(equip2).itemname, 1, 1
                                showfont 117, 49 + 7 * (equip2 - equiplist1), 95, items(equip2).itemtype, 1, 1
                        ELSE
                                showfont 27, 49 + 7 * (equip2 - equiplist1), 95, " --", 1, 1
                        END IF
                        drawbox 206, 64 * (equip2 / 39) + 50, 208, 64 * (equip2 / 39) + 52, 253, 254, 252
                        DO
                                a$ = INKEY$
                        LOOP UNTIL a$ <> ""
                        IF ASC(MID$(items(equip2).itemname, 1, 1)) <> 0 THEN
                                showfont 27, 49 + 7 * (equip2 - equiplist1), 31, items(equip2).itemname, 1, 1
                                showfont 117, 49 + 7 * (equip2 - equiplist1), 31, items(equip2).itemtype, 1, 1
                        ELSE
                                showfont 27, 49 + 7 * (equip2 - equiplist1), 31, " --", 1, 1
                        END IF
                        LINE (206, 64 * (equip2 / 39) + 50)-(208, 64 * (equip2 / 39) + 52), 253, BF
                        IF a$ = CHR$(27) THEN EXIT DO
                        IF a$ = CHR$(0) + "H" AND equip2 > 0 THEN
                                equip2 = equip2 - 1
                                IF equip2 < equiplist1 THEN
                                        movescrn 21, 49, 204, 111, 0, 7
                                        equiplist1 = equiplist1 - 1
                                        equiplist2 = equiplist2 - 1
                                        LINE (21, 49)-(204, 54), 0, BF
                                END IF
                        END IF
                        IF a$ = CHR$(0) + "P" AND equip2 < 39 THEN
                                equip2 = equip2 + 1
                                IF equip2 > equiplist2 THEN
                                        movescrn 21, 56, 204, 118, 0, -7
                                        equiplist1 = equiplist1 + 1
                                        equiplist2 = equiplist2 + 1
                                        LINE (21, 112)-(204, 117), 0, BF
                                END IF
                        END IF
                        IF a$ = " " THEN
                                SELECT CASE equip
                                        CASE 0:
                                                IF UCASE$(RTRIM$(items(equip2).itemtype)) = "WEAPON" OR ASC(items(equip2).itemname) = 0 THEN
                                                        IF ASC(weapon.weaponname) > 0 THEN
                                                                equiptemp$ = items(equip2).itemname
                                                                equiptemp2 = items(equip2).strength
                                                                items(equip2).itemname = weapon.weaponname
                                                                items(equip2).itemtype = "Weapon"
                                                                items(equip2).strength = weapon.strength
                                                                weapon.weaponname = equiptemp$
                                                                weapon.strength = equiptemp2
                                                        ELSE
                                                                weapon.weaponname = items(equip2).itemname
                                                                weapon.strength = items(equip2).strength
                                                                items(equip2).itemname = CHR$(0)
                                                                items(equip2).itemtype = CHR$(0)
                                                                items(equip2).strength = 0
                                                        END IF
                                                        LINE (27, 21)-(208, 26), 0, BF
                                                        showfont 27, 21, 31, "Weapon:               Str:", 1, 1
                                                        IF ASC(weapon.weaponname) > 0 THEN
                                                                showfont 69, 21, 171, weapon.weaponname, 1, 1
                                                                showfont 183, 21, 171, LTRIM$(STR$(weapon.strength)), 1, 1
                                                        ELSE
                                                                showfont 69, 21, 171, "-", 1, 1
                                                                showfont 183, 21, 171, "-", 1, 1
                                                        END IF
                                                        LINE (27, 49 + 7 * (equip2 - equiplist1))-(204, 54 + 7 * (equip2 - equiplist1)), 0, BF
                                                END IF
                                        CASE 1:
                                                IF UCASE$(RTRIM$(items(equip2).itemtype)) = "ARMOR" OR ASC(items(equip2).itemname) = 0 THEN
                                                        IF ASC(armor.armorname) > 0 THEN
                                                                equiptemp$ = items(equip2).itemname
                                                                equiptemp2 = items(equip2).strength
                                                                items(equip2).itemname = armor.armorname
                                                                items(equip2).itemtype = "Armor"
                                                                items(equip2).strength = armor.defense
                                                                armor.armorname = equiptemp$
                                                                armor.defense = equiptemp2
                                                        ELSE
                                                                armor.armorname = items(equip2).itemname
                                                                armor.defense = items(equip2).strength
                                                                items(equip2).itemname = CHR$(0)
                                                                items(equip2).itemtype = CHR$(0)
                                                                items(equip2).strength = 0
                                                        END IF
                                                        LINE (27, 28)-(208, 33), 0, BF
                                                        showfont 27, 28, 31, "Armor:                Def:", 1, 1
                                                        IF ASC(armor.armorname) > 0 THEN
                                                                showfont 69, 28, 171, armor.armorname, 1, 1
                                                                showfont 183, 28, 171, LTRIM$(STR$(armor.defense)), 1, 1
                                                        ELSE
                                                                showfont 69, 28, 171, "-", 1, 1
                                                                showfont 183, 28, 171, "-", 1, 1
                                                        END IF
                                                        LINE (27, 49 + 7 * (equip2 - equiplist1))-(204, 54 + 7 * (equip2 - equiplist1)), 0, BF
                                                END IF
                                        CASE 2:
                                                IF UCASE$(RTRIM$(items(equip2).itemtype)) = "SHIELD" OR ASC(items(equip2).itemname) = 0 THEN
                                                        IF ASC(shield.shieldname) > 0 THEN
                                                                equiptemp$ = items(equip2).itemname
                                                                equiptemp2 = items(equip2).strength
                                                                items(equip2).itemname = shield.shieldname
                                                                items(equip2).itemtype = "Shield"
                                                                items(equip2).strength = shield.evade
                                                                shield.shieldname = equiptemp$
                                                                shield.evade = equiptemp2
                                                        ELSE
                                                                shield.shieldname = items(equip2).itemname
                                                                shield.evade = items(equip2).strength
                                                                items(equip2).itemname = CHR$(0)
                                                                items(equip2).itemtype = CHR$(0)
                                                                items(equip2).strength = 0
                                                        END IF
                                                        LINE (27, 35)-(208, 40), 0, BF
                                                        showfont 27, 35, 31, "Shield:               Evd:", 1, 1
                                                        IF ASC(shield.shieldname) > 0 THEN
                                                                showfont 69, 35, 171, shield.shieldname, 1, 1
                                                                showfont 183, 35, 171, LTRIM$(STR$(shield.evade)), 1, 1
                                                        ELSE
                                                                showfont 69, 35, 171, "-", 1, 1
                                                                showfont 183, 35, 171, "-", 1, 1
                                                        END IF
                                                        LINE (27, 49 + 7 * (equip2 - equiplist1))-(204, 54 + 7 * (equip2 - equiplist1)), 0, BF
                                                END IF
                                END SELECT
                        END IF
                LOOP
        END IF
        IF a$ = CHR$(0) + "H" AND equip > 0 THEN equip = equip - 1
        IF a$ = CHR$(0) + "P" AND equip < 2 THEN equip = equip + 1
LOOP
putscrn 0, 0

END SUB

SUB showfont (xfnt%, yfnt%, colour%, text$, shadex%, shadey%)

IF xfnt% < 0 THEN xfnt% = 160 - xfntsize / 2 * LEN(text$)
text$ = UCASE$(text$)
FOR char% = 1 TO LEN(text$)
        char2% = ASC(MID$(text$, char%, 1))
        FOR xfnt2% = 0 TO xfntsize - 1
                FOR yfnt2% = 0 TO yfntsize - 1
                        xfnt3% = xfnt% + xfntsize * (char% - 1) + xfnt2%
                        yfnt3% = yfnt% + yfnt2%
                        IF Font(char2%, yfnt2%, xfnt2%) = 1 THEN PSET (xfnt3%, yfnt3%), colour% - xfnt2% * shadex% - yfnt2% * shadey%
                NEXT yfnt2%
        NEXT xfnt2%
NEXT char%

END SUB

SUB showitems (inbattle)

getscrn 16, 16, 213, 107
bevelbox 16, 16, 213, 107, 241, 242, 240, 0
showfont 27, 21, 171, "Use       Sort      Remove", 1, 1
drawbox 21, 29, 208, 31, 245, 246, 244
FOR item = 0 TO 9
        IF ASC(MID$(items(item).itemname, 1, 1)) <> 0 THEN
                showfont 27, 35 + 7 * item, 31, items(item).itemname, 1, 1
                showfont 117, 35 + 7 * item, 31, items(item).itemtype, 1, 1
        ELSE
                showfont 27, 35 + 7 * item, 31, " --", 1, 1
        END IF
NEXT
drawbox 205, 35, 209, 103, 253, 254, 252
itemmenu = 0
item = 0
itemlist1 = 0
itemlist2 = itemlist1 + 9
DO
        IF itemmenu = 0 THEN
                SELECT CASE item
                        CASE 0: showfont 27, 21, 95, "Use", 1, 1
                        CASE 1: showfont 87, 21, 95, "Sort", 1, 1
                        CASE 2: showfont 147, 21, 95, "Remove", 1, 1
                END SELECT
        ELSE
                IF ASC(MID$(items(item).itemname, 1, 1)) <> 0 THEN
                        showfont 27, 35 + 7 * (item - itemlist1), 95, items(item).itemname, 1, 1
                        showfont 117, 35 + 7 * (item - itemlist1), 95, items(item).itemtype, 1, 1
                ELSE
                        showfont 27, 35 + 7 * (item - itemlist1), 95, " --", 1, 1
                END IF
                drawbox 206, 64 * (item / 39) + 36, 208, 64 * (item / 39) + 38, 253, 254, 252
        END IF
        DO
                a$ = INKEY$
        LOOP UNTIL a$ <> ""
        IF itemmenu = 0 THEN
                showfont 27, 21, 171, "Use       Sort      Remove", 1, 1
        ELSE
                IF ASC(MID$(items(item).itemname, 1, 1)) <> 0 THEN
                        showfont 27, 35 + 7 * (item - itemlist1), 31, items(item).itemname, 1, 1
                        showfont 117, 35 + 7 * (item - itemlist1), 31, items(item).itemtype, 1, 1
                ELSE
                        showfont 27, 35 + 7 * (item - itemlist1), 31, " --", 1, 1
                END IF
                LINE (206, 64 * (item / 39) + 36)-(208, 64 * (item / 39) + 38), 253, BF
        END IF
        IF a$ = CHR$(27) THEN
                IF itemmenu = 0 THEN
                        EXIT DO
                ELSE
                        itemmenu = 0
                        item = 0
                END IF
        END IF
        IF itemmenu = 0 THEN
                IF a$ = CHR$(0) + "K" AND item > 0 THEN item = item - 1
                IF a$ = CHR$(0) + "M" AND item < 2 THEN item = item + 1
        ELSE
                IF a$ = CHR$(0) + "H" AND item > 0 THEN
                        item = item - 1
                        IF item < itemlist1 THEN
                                movescrn 21, 35, 204, 97, 0, 7
                                itemlist1 = itemlist1 - 1
                                itemlist2 = itemlist2 - 1
                                LINE (21, 35)-(204, 40), 0, BF
                        END IF
                END IF
                IF a$ = CHR$(0) + "P" AND item < 39 THEN
                        item = item + 1
                        IF item > itemlist2 THEN
                                movescrn 21, 42, 204, 104, 0, -7
                                itemlist1 = itemlist1 + 1
                                itemlist2 = itemlist2 + 1
                                LINE (21, 98)-(204, 103), 0, BF
                        END IF
                END IF
        END IF
        IF a$ = " " THEN
                SELECT CASE itemmenu
                        CASE 0:
                                IF item = 0 THEN
                                        item = itemlist1
                                        itemmenu = 1
                                ELSEIF item = 1 THEN
                                        itemnamesort
                                        LINE (27, 35)-(204, 103), 0, BF
                                        FOR item2 = itemlist1 TO itemlist2
                                                IF ASC(MID$(items(item2).itemname, 1, 1)) <> 0 THEN
                                                        showfont 27, 35 + 7 * (item2 - itemlist1), 31, items(item2).itemname, 1, 1
                                                        showfont 117, 35 + 7 * (item2 - itemlist1), 31, items(item2).itemtype, 1, 1
                                                ELSE
                                                        showfont 27, 35 + 7 * (item2 - itemlist1), 31, " --", 1, 1
                                                END IF
                                        NEXT
                                ELSEIF item = 2 THEN
                                        item = itemlist1
                                        itemmenu = 2
                                END IF
                        CASE 1:
                                IF inbattle = 1 THEN putscrn 0, 0
                                useitem item, inbattle
                                IF inbattle = 1 THEN EXIT SUB
                                LINE (21, 35 + 7 * (item - itemlist1))-(204, 40 + 7 * (item - itemlist1)), 0, BF
                        CASE 2: items(item).itemname = CHR$(0)
                                items(item).itemtype = CHR$(0)
                                LINE (27, 35 + 7 * (item - itemlist1))-(204, 40 + 7 * (item - itemlist1)), 0, BF
                END SELECT
        END IF
LOOP
putscrn 0, 0

END SUB

SUB showload (loaded)

getscrn 16, 16, 213, 115
bevelbox 16, 16, 213, 115, 241, 242, 240, 0


getscrn 16, 131, 62, 160
bevelbox 16, 131, 62, 160, 241, 242, 240, 0
showfont 21, 136, 31, "Slot 1", 1, 1
showfont 21, 143, 31, "Slot 2", 1, 1
showfont 21, 150, 31, "Slot 3", 1, 1
load = 1
loaded = 0

DO
        showfont 21, 129 + 7 * load, 95, "Slot" + STR$(load), 1, 1
      
        bevelbox 16, 16, 213, 115, 241, 242, 240, 0
        OPEN "rpgdemo\dat\save" + LTRIM$(STR$(load)) + ".sav" FOR INPUT AS 1
        IF LOF(1) = 0 THEN
                showfont 91, 51, 31, "(empty)", 1, 1
                canloadfile = 0
        ELSE
                INPUT #1, lname$
                INPUT #1, lhp, lmaxhp
                INPUT #1, lMP, lmaxMP
                INPUT #1, lstrength, ldenense, lspeed
                INPUT #1, lGold, lEXPoint, lLevel
                INPUT #1, lweaponname$, lweaponstr
                INPUT #1, larmorname$, larmordef
                INPUT #1, lshieldname$, lshieldevd
                showfont 21, 21, 31, "HP:", 1, 1
                showfont 33, 21, 171, STR$(lhp) + "/" + LTRIM$(STR$(lmaxhp)), 1, 1
                drawbox 93, 22, 195, 24, 0, 254, 252
                LINE (94, 23)-(94 + 100 * (lhp / lmaxhp), 23), 253
                showfont 21, 35, 31, "MP:", 1, 1
                showfont 33, 35, 171, STR$(lMP) + "/" + LTRIM$(STR$(lmaxMP)), 1, 1
                drawbox 93, 36, 195, 38, 0, 254, 252
                LINE (94, 37)-(94 + 100 * (lMP / lmaxMP), 37), 253

                drawbox 21, 50, 208, 52, 245, 246, 244

                showfont 21, 56, 31, "Str:", 1, 1
                showfont 21, 63, 31, "Def:", 1, 1
                showfont 21, 70, 31, "Spd:", 1, 1
                showfont 111, 56, 31, "G:  ", 1, 1
                showfont 111, 63, 31, "EXP:", 1, 1
                showfont 111, 70, 31, "Lvl:", 1, 1
                showfont 39, 56, 171, STR$(lstrength), 1, 1
                showfont 39, 63, 171, STR$(ldefense), 1, 1
                showfont 39, 70, 171, STR$(lspeed), 1, 1
                showfont 129, 56, 171, STR$(lGold), 1, 1
                showfont 129, 63, 171, STR$(lEXPoints), 1, 1
                showfont 129, 70, 171, STR$(lLevel), 1, 1


                drawbox 21, 85, 208, 87, 245, 246, 244

                showfont 21, 91, 31, "Weapon:", 1, 1
                showfont 135, 91, 31, "Str:", 1, 1
                showfont 21, 98, 31, "Armor:", 1, 1
                showfont 135, 98, 31, "Def:", 1, 1
                showfont 21, 105, 31, "Shield:", 1, 1
                showfont 135, 105, 31, "Evd:", 1, 1
                IF lweaponname$ <> " " THEN
                        showfont 63, 91, 171, lweaponname$, 1, 1
                        showfont 159, 91, 171, LTRIM$(STR$(lweaponstr)), 1, 1
                ELSE
                        showfont 63, 91, 171, "-", 1, 1
                        showfont 159, 91, 171, "-", 1, 1
                END IF
                IF larmorname$ <> " " THEN
                        showfont 63, 98, 171, larmorname$, 1, 1
                        showfont 159, 98, 171, LTRIM$(STR$(larmordef)), 1, 1
                ELSE
                        showfont 63, 98, 171, "-", 1, 1
                        showfont 159, 98, 171, "-", 1, 1
                END IF
                IF lshieldname$ <> " " THEN
                        showfont 63, 105, 171, lshieldname$, 1, 1
                        showfont 159, 105, 171, LTRIM$(STR$(lshieldevd)), 1, 1
                ELSE
                        showfont 63, 105, 171, "-", 1, 1
                        showfont 159, 105, 171, "-", 1, 1
                END IF
                canloadfile = 1
        END IF
        CLOSE #1
        DO
                a$ = INKEY$
        LOOP WHILE a$ = ""
        IF a$ = CHR$(27) THEN
                putscrn 0, 0
                putscrn 0, 0
                EXIT SUB
        END IF
        showfont 21, 129 + 7 * load, 31, "Slot" + STR$(load), 1, 1
        IF a$ = CHR$(0) + "H" AND load > 1 THEN load = load - 1
        IF a$ = CHR$(0) + "P" AND load < 3 THEN load = load + 1
        IF a$ = " " AND canloadfile = 1 THEN
                getscrn 70, 131, 303, 153
                bevelbox 70, 131, 290, 153, 245, 246, 244, 0
                showfont 75, 136, 171, "Load this file?", 1, 1
                showfont 135, 143, 31, "Yes       No", 1, 1
                load2 = 1
                DO
                        SELECT CASE load2
                                CASE 1: showfont 135, 143, 95, "Yes", 1, 1
                                CASE 2: showfont 195, 143, 95, "No", 1, 1
                        END SELECT
                        DO
                                a$ = INKEY$
                        LOOP WHILE a$ = ""
                        showfont 135, 143, 31, "Yes       No", 1, 1
                        IF a$ = CHR$(0) + "K" AND load2 = 2 THEN load2 = 1
                        IF a$ = CHR$(0) + "M" AND load2 = 1 THEN load2 = 2
                        IF a$ = " " THEN EXIT DO
                LOOP
                IF load2 = 1 THEN
                        OPEN "rpgdemo\dat\save" + LTRIM$(STR$(load)) + ".sav" FOR INPUT AS 1
                        INPUT #1, yourname
                        INPUT #1, hp, maxhp
                        INPUT #1, MP, maxmp
                        INPUT #1, strength, defense, speed
                        INPUT #1, Gold, expoints, level
                        INPUT #1, weapon.weaponname, weapon.strength
                        IF MID$(weapon.weaponname, 1, 1) = " " THEN
                                weapon.weaponname = CHR$(0)
                        END IF
                        INPUT #1, armor.armorname, armor.defense
                        IF MID$(armor.armorname, 1, 1) = " " THEN
                                armor.armorname = CHR$(0)
                        END IF
                        INPUT #1, shield.shieldname, shield.evade
                        IF MID$(shield.shieldname, 1, 1) = " " THEN
                                shield.shieldname = CHR$(0)
                        END IF
                        INPUT #1, mapfile$, x, y
                        FOR item = 0 TO 39
                                INPUT #1, items(item).itemname, items(item).itemtype, items(item).strength, items(item).cost
                                IF MID$(items(item).itemname, 1, 1) = " " THEN
                                        items(item).itemname = CHR$(0)
                                        items(item).itemtype = CHR$(0)
                                        items(item).strength = 0
                                        items(item).cost = 0
                                END IF
                        NEXT
                        FOR flag = 0 TO 9
                                INPUT #1, flags(flag)
                        NEXT
                        CLOSE #1
                        loadmap mapfile$
                        putscrn 0, 0
                        putscrn 0, 0
                        putscrn 0, 0
                        putscrn 0, 0
                        showscreen 0
                        loaded = 1
                        EXIT SUB
                END IF
                putscrn 0, 0
        END IF
LOOP

'END

'inkey
'putscrn 0, 0

END SUB

SUB showmagic (inbattle)

getscrn 80, 16, 153, 45 + 7 * numspells
bevelbox 80, 16, 153, 45 + 7 * numspells, 241, 242, 240, 0

showfont 85, 21, 171, "Magic", 1, 1
drawbox 85, 30, 143, 32, 245, 246, 244

FOR spell = 0 TO numspells
        IF magic(spell).learned THEN
                showfont 91, 35 + 7 * spell, 31, magic(spell).spellname, 1, 1
        ELSE
                showfont 91, 35 + 7 * spell, 31, " --", 1, 1
        END IF
NEXT
spell = 0
DO
        IF magic(spell).learned THEN
                showfont 91, 35 + 7 * spell, 95, magic(spell).spellname, 1, 1
        ELSE
                showfont 91, 35 + 7 * spell, 95, " --", 1, 1
        END IF
        DO
                a$ = INKEY$
        LOOP UNTIL a$ <> ""
        IF magic(spell).learned THEN
                showfont 91, 35 + 7 * spell, 31, magic(spell).spellname, 1, 1
        ELSE
                showfont 91, 35 + 7 * spell, 31, " --", 1, 1
        END IF
        IF a$ = CHR$(27) THEN EXIT DO
        IF a$ = CHR$(0) + "H" AND spell > 0 THEN spell = spell - 1
        IF a$ = CHR$(0) + "P" AND spell < numspells THEN spell = spell + 1
        IF a$ = " " AND magic(spell).learned = 1 THEN
                IF inbattle = 1 AND magic(spell).cost > MP THEN
                        battletext "You don't have enough MP"
                        inkey
                ELSE
                        IF inbattle = 1 THEN putscrn 0, 0
                        usemagic spell, inbattle
                        IF inbattle = 1 THEN EXIT SUB
                END IF
        END IF
LOOP
putscrn 0, 0
END SUB

