'$DYNAMIC

DECLARE SUB battle (ennum%)
DECLARE SUB battletext (text$)
DECLARE SUB bevelbox (x1%, y1%, x2%, y2%, col%, shade1%, shade2%, fill%)
DECLARE SUB changemap ()
DECLARE SUB clearscreen (mode%)
DECLARE SUB clrkbuffer ()
DECLARE SUB doscroll (scrolldir$)
DECLARE SUB doenattack (attackname$, damage%)
DECLARE SUB doitem (item%, text$)
DECLARE SUB doscript (scriptname$, scriptnum%)
DECLARE SUB dotrans (x1%, y1%, x2%, y2%)
DECLARE SUB drawbox (x1%, y1%, x2%, y2%, col%, shade1%, shade2%)
DECLARE SUB enattack (attackname$)
DECLARE SUB endgame ()
DECLARE SUB extractarray (xextract%, yextract%, array1%(), array2%())
DECLARE SUB fadeout (col1%, col2%)
DECLARE SUB fadein (col1%, col2%)
DECLARE SUB getscrn (x1%, y1%, x2%, y2%)
DECLARE SUB growbevelbox (x1%, y1%, x2%, y2%, col%, shade1%, shade2%, steps%)
DECLARE SUB growbox (x1%, y1%, x2%, y2%, col%, shade1%, shade2%, steps%)
DECLARE SUB initvars ()
DECLARE SUB inkey ()
DECLARE SUB inn (price%)
DECLARE SUB inputstring (xfnt%, yfnt%, colour%, text$, var$, maxlength%, xshade%, yshade%, bgcolor%)
DECLARE SUB inputvar (xfnt%, yfnt%, colour%, text$, var%, maxlength%, xshade%, yshade%, bgcolor%)
DECLARE SUB itemnamesort ()
DECLARE SUB itemtypesort ()
DECLARE SUB loaden (file$)
DECLARE SUB loadfont (filename$)
DECLARE SUB loadmagic (file$)
DECLARE SUB loadmap (filename$)
DECLARE SUB loadpalette (filename$)
DECLARE SUB loadshop (shopname$, numitems%)
DECLARE SUB loadsprite (file$, Spritearray%())
DECLARE SUB loadsprite2 (file$, Spritearray%())
DECLARE SUB loadtiles1 (tilename$)
DECLARE SUB loadtiles2 (tilename$)
DECLARE SUB movescrn (x1%, y1%, x2%, y2%, xoff%, yoff%)
DECLARE SUB NPCinteract (interx%, intery%)
DECLARE SUB NPCmove (NPC%, direction%)
DECLARE SUB NPCshow (NPC%)
DECLARE SUB pal (colour%, r%, g%, b%)
DECLARE SUB pastearray (xpaste%, ypaste%, array1%(), array2%(), tilenum%)
DECLARE SUB pause (seconds#)
DECLARE SUB playani (file$, anix%, aniy%, xsize%, ysize%, delay#)
DECLARE SUB playani2 (aniarray%(), tilenum1%, tilenum2%, anix%, aniy%, xchng%, ychng%, frames%, delay#)
DECLARE SUB putscrn (xoff%, yoff%)
DECLARE SUB question (speaker$, text$)
DECLARE SUB readscript ()
DECLARE SUB settrans ()
DECLARE SUB shop (shopname$)
DECLARE SUB showequip ()
DECLARE SUB showfont (xfnt%, yfnt%, colour%, text$, shadex%, shadey%)
DECLARE SUB showitems (inbattle%)
DECLARE SUB showmagic (inbattle%)
DECLARE SUB showload (loaded%)
DECLARE SUB showquit ()
DECLARE SUB showsave ()
DECLARE SUB showscreen (fade%)
DECLARE SUB showstats ()
DECLARE SUB skipscript ()
DECLARE SUB status ()
DECLARE SUB textbox (speaker$, text$)
DECLARE SUB transbox (x1%, y1%, x2%, y2%, col%, shade1%, shade2%)
DECLARE SUB useitem (item%, inbattle%)
DECLARE SUB usemagic (spell%, inbattle%)
DECLARE SUB wingame ()

TYPE rgb
        r AS INTEGER
        g AS INTEGER
        b AS INTEGER
END TYPE

TYPE mapchange
        x AS INTEGER
        y AS INTEGER
        mapname AS STRING * 12
        newx AS INTEGER
        newy AS INTEGER
END TYPE

TYPE edgemapchange
        mapname AS STRING * 12
        x AS INTEGER
        y AS INTEGER
END TYPE

TYPE NPC
        x AS INTEGER
        y AS INTEGER
        NPCname AS STRING * 12
        spriteset AS INTEGER
        direction AS INTEGER
        scriptnum AS INTEGER
END TYPE

TYPE item
        itemname AS STRING * 12
        itemtype AS STRING * 12
        strength AS INTEGER
        cost AS INTEGER
END TYPE

TYPE magic
        spellname AS STRING * 12
        level AS INTEGER
        cost AS INTEGER
        hitpercent AS INTEGER
        useoutofbattle AS INTEGER
        learned AS INTEGER
END TYPE

TYPE weapon
        weaponname AS STRING * 12
        strength AS INTEGER
END TYPE

TYPE armor
        armorname AS STRING * 12
        defense AS INTEGER
END TYPE

TYPE shield
        shieldname AS STRING * 12
        evade AS INTEGER
END TYPE

TYPE shop
        itemname AS STRING * 12
        itemtype AS STRING * 12
        strength AS INTEGER
        cost AS INTEGER
END TYPE

TYPE enemy
        hp AS INTEGER
        enname AS STRING * 8
        strength AS INTEGER
        defense AS INTEGER
        evade AS INTEGER
        speed AS INTEGER
        newgold AS INTEGER
        newexp AS INTEGER
        numattacks AS INTEGER
END TYPE
   
TYPE getscrn
        getoff AS INTEGER
        x1 AS INTEGER
        y1 AS INTEGER
        x2 AS INTEGER
        y2 AS INTEGER
END TYPE


COMMON SHARED Tiles() AS INTEGER
COMMON SHARED Tiles2() AS INTEGER
COMMON SHARED Sprites() AS INTEGER
COMMON SHARED NPCSpr() AS INTEGER
COMMON SHARED Undersprite() AS INTEGER
COMMON SHARED BattleChar() AS INTEGER
COMMON SHARED BattleEn() AS INTEGER
COMMON SHARED enemy() AS enemy
COMMON SHARED EnAttacks() AS STRING
COMMON SHARED Battlemagic() AS INTEGER
COMMON SHARED tempsprite() AS INTEGER
COMMON SHARED aniarray() AS INTEGER
COMMON SHARED Aniarray2() AS INTEGER
COMMON SHARED temparray() AS INTEGER
COMMON SHARED battlearray() AS INTEGER
COMMON SHARED battlearray2() AS INTEGER
COMMON SHARED anitemp() AS INTEGER
COMMON SHARED Map() AS INTEGER
COMMON SHARED scrn() AS INTEGER
COMMON SHARED colors() AS rgb
COMMON SHARED Font() AS INTEGER
COMMON SHARED mapchange() AS mapchange
COMMON SHARED NPCs() AS NPC
COMMON SHARED items() AS item
COMMON SHARED magic() AS magic
COMMON SHARED shopitems() AS shop
COMMON SHARED trans() AS INTEGER
COMMON SHARED gets() AS getscrn
COMMON SHARED flags() AS INTEGER

COMMON SHARED numspells AS INTEGER
COMMON SHARED rgbval AS STRING * 1
COMMON SHARED scroll AS STRING
COMMON SHARED xscrn AS INTEGER
COMMON SHARED yscrn AS INTEGER
COMMON SHARED xspr AS INTEGER
COMMON SHARED yspr AS INTEGER
COMMON SHARED nomovetile AS INTEGER
COMMON SHARED xmap AS INTEGER
COMMON SHARED ymap AS INTEGER
COMMON SHARED tilename1 AS STRING
COMMON SHARED tilename2 AS STRING
COMMON SHARED palettename AS STRING
COMMON SHARED maptype AS STRING
COMMON SHARED mapname AS STRING
COMMON SHARED mapfile AS STRING
COMMON SHARED edgemapchange AS edgemapchange
COMMON SHARED mapchanges AS INTEGER
COMMON SHARED numNPCs AS INTEGER
COMMON SHARED scriptfile AS STRING
COMMON SHARED fontname AS STRING
COMMON SHARED xfntsize AS INTEGER
COMMON SHARED yfntsize AS INTEGER
COMMON SHARED btextline AS INTEGER
COMMON SHARED responce AS STRING
COMMON SHARED x AS INTEGER
COMMON SHARED y AS INTEGER
COMMON SHARED direction AS INTEGER
COMMON SHARED charstep AS INTEGER
COMMON SHARED yourname AS STRING
COMMON SHARED hp AS INTEGER
COMMON SHARED maxhp AS INTEGER
COMMON SHARED MP AS INTEGER
COMMON SHARED maxmp AS INTEGER
COMMON SHARED strength AS INTEGER
COMMON SHARED defense AS INTEGER
COMMON SHARED speed AS INTEGER
COMMON SHARED level AS INTEGER
COMMON SHARED Gold AS LONG
COMMON SHARED expoints AS LONG
COMMON SHARED weapon AS weapon
COMMON SHARED armor AS armor
COMMON SHARED shield AS shield
COMMON SHARED bstrength AS INTEGER
COMMON SHARED bdefense AS INTEGER
COMMON SHARED bspeed AS INTEGER
COMMON SHARED evade AS INTEGER
COMMON SHARED enname AS STRING
COMMON SHARED enHP AS INTEGER
COMMON SHARED enstrength AS INTEGER
COMMON SHARED endefense AS INTEGER
COMMON SHARED enspeed AS INTEGER
COMMON SHARED enevade AS INTEGER
COMMON SHARED numattacks AS INTEGER
COMMON SHARED getoff AS INTEGER
COMMON SHARED getnum AS INTEGER

DEFINT A-Z

REM $STATIC
SUB inn (price)

question "Inn", "The inn costs" + STR$(price) + ".  Do you want to stay?"
IF responce = "yes" THEN
        hp = maxhp
        MP = maxmp
        textbox "INN", "Thank you.  Your HP and MP have been restored"
END IF

END SUB

SUB inputstring (xfnt%, yfnt%, colour%, text$, var$, maxlength%, xshade%, yshade%, bgcolor%)

showfont xfnt%, yfnt%, colour%, text$, xshade%, yshade%
IF xfnt% < 0 THEN xfnt% = 160 - 4 * LEN(text$)
x1% = xfnt% + xfntsize * LEN(text$) + b%
y1% = yfnt%
var$ = ""
length% = 0
DO
        time& = TIMER
        IF length% < maxlength% THEN showfont x1%, y1%, colour%, "_", xshade%, yshade%
        DO
                a$ = INKEY$
                IF TIMER - time& > .5 AND length% < maxlength% THEN
                        showfont x1%, y1%, 0, "_", 0, 0
                END IF
                IF TIMER - time& > 1 AND length% < maxlength% THEN
                        time& = time& + 1
                        showfont x1%, y1%, colour%, "_", xshade%, yshade%
                END IF
        LOOP UNTIL a$ <> ""
        showfont x1%, y1%, 0, "_", 0, 0
        SELECT CASE ASC(a$)
                CASE 32 TO 122
                        IF length% < maxlength% THEN
                                showfont x1%, y1%, colour%, a$, xshade%, yshade%
                                var$ = var$ + a$
                                x1% = x1% + xfntsize
                                length% = length% + 1
                        END IF
                CASE 8:
                        IF length% > 0 THEN
                                IF length% < maxlength% THEN showfont x1%, y1%, 0, "_", 0, 0
                                length% = length% - 1
                                var$ = MID$(var$, 1, LEN(var$) - 1)
                                x1% = x1% - xfntsize
                        END IF
                CASE 13: EXIT SUB
        END SELECT
LOOP

END SUB

SUB inputvar (xfnt%, yfnt%, colour%, text$, var%, maxlength%, xshade%, yshade%, bgcolor%)

showfont xfnt%, yfnt%, colour%, text$, xshade%, yshade%
IF xfnt% < 0 THEN xfnt% = 160 - 4 * LEN(text$)
x1% = xfnt% + xfntsize * LEN(text$)
y1% = yfnt%
var% = 0
length% = 0
DO
        time& = TIMER
        IF length% < maxlength% THEN showfont x1%, y1%, colour%, "_", xshade%, yshade%
        DO
                a$ = INKEY$
                IF TIMER - time& > .5 AND length% < maxlength% THEN
                        showfont x1%, y1%, 0, "_", 0, 0
                END IF
                IF TIMER - time& > 1 AND length% < maxlength% THEN
                        time& = time& + 1
                        showfont x1%, y1%, colour%, "_", xshade%, yshade%
                END IF
        LOOP UNTIL a$ <> ""
        showfont x1%, y1%, 0, "_", 0, 0
        SELECT CASE ASC(a$)
                CASE 48 TO 56
                        IF length% < maxlength% THEN
                                showfont x1%, y1%, colour%, a$, xshade%, yshade%
                                var% = 10 * var% + ASC(a$) - 48
                                x1% = x1% + xfntsize
                                length% = length% + 1
                        END IF
                CASE 8:
                        IF length% > 0 THEN
                                length% = length% - 1
                                var% = INT(var% / 10)
                                x1% = x1% - xfntsize
                                showfont x1%, y1%, 0, "_", 0, 0
                        END IF
                CASE 13: EXIT SUB
        END SELECT
LOOP

END SUB

SUB itemnamesort

FOR itemsort = 1 TO 39
        IF ASC(MID$(items(itemsort).itemname, 1, 1)) > 0 THEN
                FOR itemsort2 = itemsort TO 1 STEP -1
                        IF items(itemsort2).itemname < items(itemsort2 - 1).itemname OR ASC(MID$(items(itemsort2 - 1).itemname, 1, 1)) = 0 THEN
                                itemtemp$ = items(itemsort2 - 1).itemname
                                items(itemsort2 - 1).itemname = items(itemsort2).itemname
                                items(itemsort2).itemname = itemtemp$
                                itemtemp$ = items(itemsort2 - 1).itemtype
                                items(itemsort2 - 1).itemtype = items(itemsort2).itemtype
                                items(itemsort2).itemtype = itemtemp$
                        END IF
                NEXT
        END IF
NEXT
itemtypesort

END SUB

SUB itemtypesort

FOR itemsort = 1 TO 39
        IF ASC(MID$(items(itemsort).itemtype, 1, 1)) > 0 THEN
                FOR itemsort2 = itemsort TO 1 STEP -1
                        IF items(itemsort2).itemtype < items(itemsort2 - 1).itemtype OR ASC(MID$(items(itemsort2 - 1).itemname, 1, 1)) = 0 THEN
                                itemtemp$ = items(itemsort2 - 1).itemtype
                                items(itemsort2 - 1).itemtype = items(itemsort2).itemtype
                                items(itemsort2).itemtype = itemtemp$
                                itemtemp$ = items(itemsort2 - 1).itemname
                                items(itemsort2 - 1).itemname = items(itemsort2).itemname
                                items(itemsort2).itemname = itemtemp$
                        END IF
                NEXT
        END IF
NEXT
END SUB

SUB loaden (file$)

OPEN "rpgdemo\dat\" + file$ FOR INPUT AS 1
INPUT #1, numens
REDIM enemy(1 TO numens) AS enemy
REDIM EnAttacks(1 TO numens, 1 TO 5) AS STRING
FOR enload = 1 TO numens
        INPUT #1, enemy(enload).enname
        INPUT #1, enemy(enload).hp
        INPUT #1, enemy(enload).strength
        INPUT #1, enemy(enload).defense
        INPUT #1, enemy(enload).evade
        INPUT #1, enemy(enload).speed
        INPUT #1, enemy(enload).newgold
        INPUT #1, enemy(enload).newexp
        INPUT #1, enemy(enload).numattacks
        FOR attack = 1 TO enemy(enload).numattacks
                INPUT #1, EnAttacks(enload, attack)
        NEXT
NEXT
CLOSE #1

END SUB

SUB loadfont (file$)

SHARED Font() AS INTEGER
OPEN "rpgdemo\dat\" + file$ FOR INPUT AS 1
INPUT #1, xfntsize, yfntsize
REDIM Font(0 TO 122, yfntsize - 1, xfntsize - 1) AS INTEGER
FOR a = 33 TO 122
        FOR c = 0 TO yfntsize - 1
                FOR b = 0 TO xfntsize - 1
                        INPUT #1, d
                        Font(a, c, b) = d
                NEXT
        NEXT
NEXT
CLOSE #1

END SUB

SUB loadmagic (file$)

SHARED numspells AS INTEGER
OPEN "rpgdemo\dat\" + file$ FOR INPUT AS 1
INPUT #1, numspells
REDIM magic(numspells) AS magic
FOR mload = 0 TO numspells
        INPUT #1, magic(mload).spellname
        INPUT #1, magic(mload).level
        INPUT #1, magic(mload).cost
        INPUT #1, magic(mload).hitpercent
        INPUT #1, magic(mload).useoutofbattle
        IF magic(mload).level > level THEN
                magic(mload).learned = 0
        ELSE
                magic(mload).learned = 1
        END IF
NEXT
CLOSE #1

END SUB

SUB loadmap (file$)

mapfile = file$
OPEN "rpgdemo\maps\" + file$ FOR INPUT AS 1

INPUT #1, maptype
INPUT #1, xmap, ymap
IF maptype = "world" THEN
        REDIM Map(ymap - 1, xmap - 1, 1) AS INTEGER
ELSE
        REDIM Map(ymap - 1, xmap - 1, 2) AS INTEGER
END IF
FOR y2 = 0 TO ymap - 1
        FOR x2 = 0 TO xmap - 1
                INPUT #1, Map(y2, x2, 0)
        NEXT
NEXT

INPUT #1, junk
FOR y2 = 0 TO ymap - 1
        FOR x2 = 0 TO xmap - 1
                INPUT #1, Map(y2, x2, 1)
        NEXT
NEXT

INPUT #1, junk
INPUT #1, tileset1name$
IF maptype <> "world" THEN INPUT #1, tileset2name$
INPUT #1, junk
INPUT #1, mapname
INPUT #1, junk
INPUT #1, nomovetile
INPUT #1, junk

IF maptype <> "world" THEN
        INPUT #1, edgemapchange.mapname
        INPUT #1, edgemapchange.x
        INPUT #1, edgemapchange.y
        INPUT #1, junk
END IF

INPUT #1, mapchanges

IF mapchanges > 0 THEN
        REDIM mapchange(mapchanges - 1) AS mapchange
        FOR mapchange = 0 TO mapchanges - 1
                INPUT #1, mapchange(mapchange).x
                INPUT #1, mapchange(mapchange).y
                INPUT #1, mapchange(mapchange).mapname
                INPUT #1, mapchange(mapchange).newx
                INPUT #1, mapchange(mapchange).newy
        NEXT
END IF

IF maptype <> "world" THEN
        INPUT #1, junk
        INPUT #1, numNPCs
        IF numNPCs > 0 THEN
                REDIM NPCs(1 TO numNPCs) AS NPC
                FOR NPC = 1 TO numNPCs
                        INPUT #1, NPCs(NPC).x
                        INPUT #1, NPCs(NPC).y
                        INPUT #1, NPCs(NPC).NPCname
                        Map(NPCs(NPC).y, NPCs(NPC).x, 2) = NPC
                        INPUT #1, NPCs(NPC).spriteset
                        INPUT #1, NPCs(NPC).scriptnum
                        NPCs(NPC).direction = 0
                NEXT
        END IF
        INPUT #1, junk
        INPUT #1, scriptfile
END IF

CLOSE #1

loadtiles1 tileset1name$
IF maptype <> "world" THEN loadtiles2 tileset2name$


END SUB

SUB loadpalette (file$)

IF file$ <> palettename THEN
        palettename = file$
        OPEN "rpgdemo\dat\" + file$ FOR BINARY AS #1
        FOR colour% = 0 TO 255
                GET #1, , rgbval
                colors(colour%).r = ASC(rgbval)
                GET #1, , rgbval
                colors(colour%).g = ASC(rgbval)
                GET #1, , rgbval
                colors(colour%).b = ASC(rgbval)
                pal colour%, colors(colour%).r, colors(colour%).g, colors(colour%).b
          NEXT
        CLOSE #1
END IF

END SUB

SUB loadshop (shopname$, numitems)

OPEN "rpgdemo\dat\" + shopname$ FOR INPUT AS 1
INPUT #1, numitems
REDIM shopitems(numitems) AS shop
FOR shopitem = 1 TO numitems
        INPUT #1, shopitems(shopitem).itemname
        INPUT #1, shopitems(shopitem).itemtype
        INPUT #1, shopitems(shopitem).strength
        INPUT #1, shopitems(shopitem).cost
NEXT
CLOSE 1

END SUB

SUB loadsprite (file$, Spritearray%())

'OPEN "rpgdemo\tiles\" + file$ FOR BINARY AS 1
'Ints = (LOF(1) - 27) / 2
'numtiles = Ints / 129 / 2 - 1
'CLOSE 1

DEF SEG = VARSEG(Spritearray%(0, 0, 0))
BLOAD "rpgdemo\tiles\" + file$, 0
DEF SEG

END SUB

SUB loadsprite2 (file$, Spritearray%())

'OPEN "rpgdemo\tiles\" + file$ FOR BINARY AS 1
'Ints = (LOF(1) - 27) / 2
'numtiles = Ints / 129 / 2 - 1
'CLOSE 1

DEF SEG = VARSEG(Spritearray%(0, 0, 0, 0))
BLOAD "rpgdemo\tiles\" + file$, 0
DEF SEG

END SUB

SUB loadtiles1 (tilename$)

IF tilename$ <> tilename1 THEN
        tilename1 = tilename$
        OPEN "rpgdemo\tiles\" + tilename$ FOR BINARY AS 1
        Ints = (LOF(1) - 7) / 2
        numtiles = Ints / 129 - 1
        CLOSE 1
        REDIM Tiles(129, numtiles, 0) AS INTEGER
        DEF SEG = VARSEG(Tiles(0, 0, 0))
        BLOAD "rpgdemo\tiles\" + tilename$, 0
        DEF SEG
END IF

END SUB

SUB loadtiles2 (tilename$)

IF tilename$ <> tilename2 THEN
        tilename2 = tilename$
        OPEN "rpgdemo\tiles\" + tilename$ FOR BINARY AS 1
        Ints = (LOF(1) - 7) / 2
        numtiles = Ints / 129 / 2 - 1
        CLOSE 1
        REDIM Tiles2(129, numtiles, 1) AS INTEGER
        DEF SEG = VARSEG(Tiles2(0, 0, 0))
        BLOAD "rpgdemo\tiles\" + tilename$, 0
        DEF SEG
END IF

END SUB

SUB movescrn (x1, y1, x2, y2, xoff, yoff)

getscrn x1, y1, x2, y2
putscrn xoff, yoff

END SUB

SUB NPCinteract (interx%, intery%)

NPC = Map(intery%, interx%, 2)
scriptnum = NPCs(NPC).scriptnum
NPCname$ = NPCs(NPC).NPCname
doscript scriptfile, scriptnum

END SUB

SUB NPCmove (NPC, direction)

NPCx = NPCs(NPC).x
NPCy = NPCs(NPC).y
Map(NPCy, NPCx, 2) = 0

IF NPCx >= x - xscrn AND NPCx <= x + xscrn AND NPCy >= y - yscrn AND NPCy <= y + yscrn THEN
        NPCx2 = 16 * (NPCx - x + xscrn) + 8
        NPCy2 = 16 * (NPCy - y + yscrn) + 8
        PUT (NPCx2, NPCy2), Tiles(0, Map(NPCy, NPCx, 0), 0), PSET
        IF Map(NPCy, NPCx, 1) > 0 THEN
                PUT (NPCx2, NPCy2), Tiles2(0, Map(NPCy, NPCx, 1) - 1, 1), AND
                PUT (NPCx2, NPCy2), Tiles2(0, Map(NPCy, NPCx, 1) - 1, 0), OR
        END IF
END IF

NPCdir = direction
SELECT CASE NPCdir
        CASE 0: NPCy = NPCy + 1
        CASE 1: NPCx = NPCx + 1
        CASE 2: NPCy = NPCy - 1
        CASE 3: NPCx = NPCx - 1
END SELECT

NPCs(NPC).x = NPCx
NPCs(NPC).y = NPCy
NPCs(NPC).direction = NPCdir
Map(NPCy, NPCx, 2) = NPC

NPCshow NPC

END SUB

SUB NPCshow (NPC)

NPCx = NPCs(NPC).x
NPCy = NPCs(NPC).y
NPCdir = NPCs(NPC).direction

IF NPCx >= x - xscrn AND NPCx <= x + xscrn AND NPCy >= y - yscrn AND NPCy <= y + yscrn THEN
        NPCx2 = 16 * (NPCx - x + xscrn) + 8
        NPCy2 = 16 * (NPCy - y + yscrn) + 8
        NPCspriteset% = NPCs(NPC).spriteset
        PUT (NPCx2, NPCy2), NPCSpr(0, NPCdir, NPCspriteset%, 1), AND
        PUT (NPCx2, NPCy2), NPCSpr(0, NPCdir, NPCspriteset%, 0), OR
        IF Map(NPCy, NPCx, 1) > 0 THEN
                PUT (NPCx2, NPCy2), Tiles2(0, Map(NPCy, NPCx, 1) - 1, 1), AND
                PUT (NPCx2, NPCy2), Tiles2(0, Map(NPCy, NPCx, 1) - 1, 0), OR
        END IF
END IF

END SUB

SUB pal (colour%, r%, g%, b%)
OUT &H3C8, colour%
OUT &H3C9, r%
OUT &H3C9, g%
OUT &H3C9, b%
END SUB

SUB pastearray (xpaste%, ypaste%, array1%(), array2%(), tilenum%)

xsize1 = array1%(0, tilenum%, 0) / 8
ysize1 = array1%(1, tilenum%, 0)
xsize2 = array2%(0) / 8
ysize2 = array2%(1)

FOR ypaste2 = ypaste% TO ypaste% + ysize1 - 1
        FOR xpaste2 = xpaste% TO xpaste% + xsize1 - 1
                IF xpaste2 < xsize2 AND xpaste2 >= 0 AND ypaste2 < ysize2 AND ypaste2 >= 0 THEN
                        clipspace1! = 2 + (xsize1 * (ypaste2 - ypaste%) + (xpaste2 - xpaste%)) / 2
                        cliparray1 = INT(clipspace1!)
                        clipspace2! = 2 + (xsize2 * ypaste2 + xpaste2) / 2
                        cliparray2 = INT(clipspace2!)
                        IF clipspace1! = cliparray1 THEN
                                colour1 = array1%(cliparray1, tilenum%, 0) - 256 * INT(array1%(cliparray1, tilenum%, 0) / 256)
                        ELSE
                                colour1 = INT(array1%(cliparray1, tilenum%, 0) / 256)
                        END IF
                        IF colour1 <> 0 THEN
                                IF clipspace2! = cliparray2 THEN
                                        array2%(cliparray2) = colour1 + 256 * INT(array2%(cliparray2) / 256)
                                ELSE
                                        array2%(cliparray2) = colour1 * 256& + array2%(cliparray2) - 256 * INT(array2%(cliparray2) / 256)
                                END IF
                        END IF
                END IF
        NEXT xpaste2
NEXT ypaste2

END SUB

SUB pause (secs#)

time# = TIMER
DO
LOOP UNTIL TIMER - time# >= secs# 'OR INKEY$ <> ""

END SUB

SUB playani (file$, anix%, aniy%, xsize%, ysize%, delay#)

OPEN "rpgdemo\ani\" + file$ FOR BINARY AS 1
Ints = (LOF(1) - 7) / 2
numtiles = Ints / (xsize% * ysize% / 2 + 1) - 1
CLOSE 1
REDIM aniarray(xsize% * ysize% / 2 + 1, numtiles) AS INTEGER
DEF SEG = VARSEG(aniarray(0, 0))
BLOAD "rpgdemo\ani\" + file$, 0
DEF SEG

FOR frame = 0 TO numtiles
        PUT (anix%, aniy%), aniarray(0, frame), PSET
        pause delay#
NEXT

END SUB

